<?
/*
 -------------------------------------------------------------------------
 AllMyStats V1.59 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------
*/

// ----------------------------------------------------------------------------
// Extraction des mots clés quand les référants sont des moteurs de recherche
// ----------------------------------------------------------------------------
/*
# Liste originale. Quelques variables modifiées pour coller à la réalité actuelle
yahoo.com p=
altavista.com q=
google.com q=
lycos.com query=
hotbot.com query=
msn.com q=
webcrawler searchText= N'est plus OK
excite q=
recherche.netscape.fr query=
alltheweb.com q=

# Moteurs français ajoutés.
google.fr q=
vachercher.lycos.fr query=
msn.fr q=
voila.fr rdata==
rechercher.aliceadsl.fr qs=
recherche.aol.fr q=
www.aolrecherche.aol.fr query=
search.free.fr qs=
www.seek.fr qry_str=
www.chello.fr q1=

# Autres moteurs (annuaires) ajoutés.
looksmart.com key=
search.dmoz.org search=

*/

function MotsCles($ref, $ref_host) {

  $motscles = "";
  
  $url = parse_url($ref);
  $query = $url["query"];
  $host  = $url["host"];
  
  parse_str($query);

  //Pour les adwords l'url est trouvée car dans visiteur.php est ajouté au referer 
  //$Referer = urldecode($Url_syndication[0]). '?googlesyndication=1' ou '&googlesyndication=1';
  if ($googlesyndication==1) {
  	$motscles = $ref;
  }

  if ($host == 'fr.dir.yahoo.com') {
	$motscles = '['.trim((strtolower($p))).']';
	$ref_host = 'Yahoo !';

  } elseif (strstr($host,'search.yahoo') <> '' && $p) {
	$motscles = '['.trim((strtolower($p))).']';
	$ref_host = 'Yahoo !';

  } elseif ($host == 'search.voila.com' || $host == 'search.voila.fr' || $host == 'search.ke.voila.fr') {
	$motscles = '['.trim((strtolower($rdata))).']';
	$ref_host = 'Voila';

  } elseif (strstr($host,'images.google') <> '') {
	$motscles = '['.trim((strtolower($q))).']';
	$ref_host = 'Google images';

  } elseif (strstr($host,'google') <> '' && $q || $as_q) { //as_q vu pour la 1ere fois le 01-09-2009
	if ($q) { $motscles = '['.trim((strtolower($q))).']'; }
	if ($as_q) { $motscles = '['.trim((strtolower($as_q))).']'; }
	$ref_host = 'Google';

  } elseif ((strstr($host,'216.239.59.104') <> '' || strstr($host,'209.85.135.104') <> ''|| strstr($host,'209.85.129.104') <> '') && $q ) {
	$CacheMot = explode( '/',($q));
	$motscles = 'Google cache['.trim($CacheMot[sizeof($CacheMot)-1]).']';
	$ref_host = 'Google';

  } elseif (strstr($host,'search.live') <> '' || strstr($host,'search.msn') <> '') {
	$motscles = '['.trim((strtolower($q))).']';
	$ref_host = 'MSN';

  } elseif (strstr($host,'excite') <> '') {
	$motscles = '['.trim((strtolower($q))).']';
	$ref_host = 'Excite';

  } elseif (strstr($host,'webring') <> '') {
	$motscles = '['.trim((strtolower($ring))).']';
	$ref_host = 'ring';

  } elseif (strstr($host,'dada.net') <> '') {
	$motscles = '['.trim((strtolower($q))).']';
	$ref_host = 'ring';

  } elseif (strstr($host,'altavista') <> '') {
	$motscles = '['.trim((strtolower($q))).']';
	$ref_host = 'AltaVista';

  } elseif (strstr($host,"recherche.aol.fr") <> '' || strstr($host,"search.hp.my.aol") <> '' || strstr($host,"search.aol.com") <> '') { // pour www.aolrecherche.aol.fr et www.recherche.aol.fr
	if ($q <>'') {
		$motscles = '['.trim((strtolower($q))).']';
	} else {
		$motscles = '['.trim((strtolower($query))).']';
	}
	$ref_host = 'AOL recherche';
	
  } elseif (strstr($host,"rechercher.aliceadsl.fr") <> '') {
	$motscles = '['.trim((strtolower($qs))).']';
	$ref_host = 'Aliceadsl (Tiscali)';

  } elseif (strstr($host,'vachercher.lycos') <> '' || strstr($host,'www.lycos.fr') <> '') {
	$motscles = '['.trim((strtolower($query))).']';
	$ref_host = 'Lycos';
  
  } elseif ($host == 'hotbot.lycos.com') {
	$motscles = '['.trim((strtolower($MT))).']';
	$ref_host = 'Lycos';

  } elseif (strstr($host,'search.free') <> '' && $q) { // Mais pas tjrs  http://search.free.fr/google.pl?next=/search?q= (avant c'était $qs)
	$motscles = '['.trim((strtolower($q))).']';
	$ref_host = 'Free';

  } elseif (strstr($host,'seek') <> '') {
	$motscles = ' ['.trim((strtolower($qry_str))).']'; // Si pas espace avant [ --> ne marche pas ???
	$ref_host = 'Seek';

  } elseif (strstr($host,'www.chello.fr') <> '') {
	$motscles = ' ['.trim((strtolower($q1))).']'; 
	$ref_host = 'chello.fr';

  } elseif (strstr($host,'search.sweetim') <> '') {
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'Sweetim';

  } elseif (strstr($host,'pagebull') <> '') {
	$motscles = ' ['.trim((strtolower($qIn))).']';
	$ref_host = 'Pagebull';

  } elseif (strstr($host,'picsearch') <> '') {
	$motscles = ' ['.trim((strtolower($q))).']';
	$ref_host = 'Picsearch';

  } elseif (strstr($host,'recherche.hit-parade.com') <> '') {
	$motscles = ' ['.trim((strtolower($p7))).']'; 
	$ref_host = 'recherche.hit-parade.com';

  } elseif (strstr($host,'www.veosearch.com') <> '') {
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'Veosearch.com';

  } elseif (strstr($host,'search15.conduit.com') <> '') {
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'search15.conduit.com';

  } elseif (strstr($host,'www.toile.com') <> '') {
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'www.toile.com';

  } elseif (strstr($host,'www.bing.com') <> '') { 
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'www.bing.com';

  } elseif (strstr($host,'lo.st') <> '') { 
	$motscles = ' ['.trim((strtolower($x_query))).']'; 
	$ref_host = 'lo.st';

  } elseif (strstr($host,'exalead') <> '') { 
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'exalead';

  } elseif (strstr($host,'search.conduit.com') <> '') { 
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'search.conduit.com';

  } elseif (strstr($host,'search.babylon.com') <> '') { 
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'search.babylon.com';

  } elseif (strstr($host,'hooseek.com') <> '') { 
	if ($q <>'') {
		$motscles = '['.trim((strtolower($q))).']';
	} else {
		$motscles = '['.trim((strtolower($recherche))).']';
	}
	$ref_host = 'hooseek.com';

  } elseif (strstr($host,'search.twitter.com') <> '') {    // No OK moteur de recherche interne
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'search.twitter.com';

  } elseif (strstr($host,'search.incredimail.com') <> '') {  
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'search.incredimail.com';

  } elseif (strstr($host,'ask.com') <> '') {  
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'ask.com';

  } elseif (strstr($host,'yougoo.fr') <> '') {  //Depend de Yahoo
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'yougoo.fr';

  } elseif (strstr($host,'searchqu.com') <> '') {  
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'searchqu.com';

  } elseif (strstr($host,'fastbrowsersearch.com') <> '') {  
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'fastbrowsersearch.com';

  } elseif (strstr($host,'search.bluewin.ch') <> '') {  
	//$motscles = ' ['.trim((strtolower($query))).']'; 
	$motscles = ' ['.trim((strtolower($searchterm))).']'; //04-01-2010
	$ref_host = 'search.bluewin.ch';

  } elseif (strstr($host,'search.netscape.com') <> '') {  
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'search.netscape.com ';

  } elseif (strstr($host,'alltheweb.com') <> '') {  
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'alltheweb';

  } elseif (strstr($host,'doona.fr') <> '') {  
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'doona.fr';

  //--------- Search Engine Cyrillic ------------------
  } elseif (strstr($host,'yandex') <> '' && $host <> 'mail.yandex') {  // .ru Russian, .com, .ua Ukraine, .by Biélorussie
	if ($text <>'') {
		$motscles = '['.trim((strtolower($text))).']';
	} else {
		$motscles = '['.trim((strtolower($query))).']';
	}
	$ref_host = 'yandex';

  } elseif (strstr($host,'rambler.ru') <> '') {		//only .ru ?
	if ($query <>'') {
		$motscles = '['.trim((strtolower($query))).']';
	} else {
		$motscles = '['.trim((strtolower($words))).']';
	}
	$ref_host = 'rambler.ru';

  } elseif (strstr($host,'metabot.ru') <> '') {  	//only .ru ?
	$motscles = ' ['.trim((strtolower($st))).']'; 
	$ref_host = 'metabot.ru';

  } elseif (strstr($host,'aport.ru') <> '') {  		//only .ru ?
	$motscles = ' ['.trim((strtolower($r))).']'; 
	$ref_host = 'aport.ru';

  } elseif ( strstr($host,'mail.ru') <> '' &&  $host <> 'win.mail.ru')  {  		//only .ru ?
	$motscles = ' ['.trim((strtolower($q))).']'; 
	$ref_host = 'mail.ru';
  //--------------------------------------------------
  }



  
  if ($motscles != "") {
    //return stripslashes(htmlentities($motscles)); // pas OK pour Russe
    return $motscles;
  }
	
	
} // End function
?>

