<?php 
header('Content-Type: text/html; charset=utf-8');
/*
 -------------------------------------------------------------------------
 AllMyStats V1.59 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------
*/

if (function_exists('error_reporting')) {
	//error_reporting(E_ALL);
	error_reporting(E_ALL ^ E_NOTICE);
}

require_once('application_top.php');
require_once('includes/functions/general.php');


	//------ cookie (ne pas compter ses propres visites) ---------------
$SetCookie = $_POST["SetCookie"];
$DeleteCookie = $_POST["DeleteCookie"];

	if (isset($SetCookie)) {
		// Envoi d'un cookie qui s'effacera le 1er janvier 2020
		setcookie("AllMyStatsVisites","No record this",mktime(0,0,0,1,1,2020),"/",$site,0);
	}

	if (isset($DeleteCookie)) {
		// Supprime le cookie
		setcookie("AllMyStatsVisites","",0,"/",$site,0); //OK
	}
//----------------------------------------------------------------------

$submit_test_jetlag = $_POST["submit_test_jetlag"];
$jetlag_not_ok = $_POST["jetlag_not_ok"];
$jetlag_OK = $_POST["jetlag_OK"];
$langue = $_POST["langue"];
$submit_langage_OK = $_POST["submit_langage_OK"];
$jetlag = $_POST["jetlag"];

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
<html>
<head>
<!-- <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"> 

<link rel="stylesheet" type="text/css" href="stylesheet.css">
</head>
<body>
<?php
//----------------------------------------------------------------------------------------------
################################### INSTALL ####################################################

	if(file_exists('config_allmystats.php')) {
		require "config_allmystats.php";
  		require('includes/mysql_tables.php');
	} else { //config_allmystats.php n'existe pas
		if(!$langue) { $langue = 'fr'; }
		require ("includes/languages/".$langue."/main.php");
	?>
		<p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p>
		<table align="center" cellpadding="1" cellspacing="0" class="TABLEBORDER">
		  <tr>
			<td>
			  <table cellpadding="5" cellspacing="0" class="TABLEFRAME">
				<tr>
				  <TH class="TABLETITLE"><?php echo MSG_INSTALL_TITLE; ?></TH>
				  </tr>
				<tr>
				  <td colspan="2">
					<table border="1" cellpadding="2" cellspacing="0" class="TABLEDATA">
						<tr><td class="TABLEARCHIVE"><br />

						<?php
						if (!isset($submit_langage_OK) && !isset($submit_test_jetlag) && !isset($jetlag_not_ok)){
							echo MSG_INSTALL_LANGUAGES;
						?>
							<form action="<?php $PHP_SELF ?>" method="post" name="choose_langage">
								<select name="langue">
								  <option selected value="<?php echo $langue; ?>">francais</option>

								  <option value="fr">francais</option>
								  <option value="en">english</option>
								</select><br><br>
								<input type="submit" name="submit_langage_OK" value="OK">
							</form>
						<?php 
						} else {

							require ("includes/languages/".$langue."/main.php");
							
							if(!$jetlag ) { $jetlag = "0"; }
							echo MSG_JETLAG; ?> 
							
							<form action="<?php $PHP_SELF?>" method="post" name="Test_jetlag">
								<input name="langue" type="hidden" value="<?php echo $langue ?>">
								<?php 
								if (isset($submit_test_jetlag) ) {
									echo '<select name="jetlag" disabled="disabled">';
								} else {
									echo '<select name="jetlag">';
								} ?>
								
								  <option value="<?php echo $jetlag ?>" selected><?php echo $jetlag ?></option>
								  <option value="-1">-1</option>
								  <option value="-2">-2</option>
								  <option value="-3">-3</option>
								  <option value="-4">-4</option>								  
								  <option value="-5">-5</option>								  
								  <option value="-6">-6</option>								  
								  <option value="-7">-7</option>								  
								  <option value="-8">-8</option>								  
								  <option value="-9">-9</option>
								  <option value="-10">-10</option>
								  <option value="-11">-11</option>								  
								  <option value="0">0</option>
								  <option value="+1">+1</option>								  
								  <option value="+2">+2</option>								  
								  <option value="+3">+3</option>								  
								  <option value="+4">+4</option>								  
								  <option value="+5">+5</option>								  
								  <option value="+6">+6</option>								  
								  <option value="+7">+7</option>							  
								  <option value="+8">+8</option>								  
								  <option value="+9">+9</option>								  
								  <option value="+10">+10</option>								  
								  <option value="+11">+11</option>								  
								  <option value="+12">+12</option>								  
							    </select>
								
								<?php
								$date = date('d/m/Y',strtotime($jetlag." hours", strtotime(date("Y-m-d H:i:s"))));
								$heure = date('H:i',strtotime($jetlag." hours", strtotime(date("Y-m-d H:i:s"))));
								
								if (!isset($submit_test_jetlag) ){	?>
									<br>
									<input type="submit" name="submit_test_jetlag" value="Test <?php echo MSG_JETLAG ?>">
									<?php
								}
								
								if (isset($submit_test_jetlag) && !isset($jetlag_OK) ){	?>
									<table border="0" align="center" cellpadding="7">
									  <tr>
										<td nowrap><?php
											echo MSG_INSTALL_SAME_DATE."<br>";
											echo "<big>Date = <strong>".$date."</strong></big><br>";
											echo "<Big>Heure = <strong>".$heure."</strong></big><br>";	
										?>
											<input name="langue" type="hidden" value="<?php echo $langue ?>">
											<input name="jetlag" type="hidden" value="<?php echo $jetlag ?>">
											<input type="submit" name="jetlag_not_ok" value="No">&nbsp;&nbsp;
							 </form>
										<form action="install/install.php" method="post" name="pre_conf_ok">
											<?php $path_allmystats_abs = dirname($_SERVER["PHP_SELF"]); ?>
											<input name="langue" type="hidden" value="<?php echo $langue ?>">
											<input name="jetlag" type="hidden" value="<?php echo $jetlag ?>">
											<input name="path_allmystats_abs" type="hidden" value="<?php echo $path_allmystats_abs ?>">
											<input type="submit" name="jetlag_OK" value="Yes">
										</form>
											
											<br>
										</td>
									  </tr>
									</table>									
						 <?php
								}
						} 
		exit;
	}
?>
</table></td></tr></table></td></tr></table><br />
<?php
##################################################################################################
	require ("includes/languages/".$langue."/main.php");
	
	mysql_connect($mysql_host,$mysql_login,$mysql_pass);
	mysql_select_db($mysql_dbnom);

	//Pour serveur php config windows-1251, il n'est pas nÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©cessaire de faire SET NAMES 'utf8 dans visiteurs.php (peut ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Âªtre que c'est dÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â©finit dans la page principale ?
	//mais il faut le faire pour la lecture ici.(dans index_frame.php)
	//mysql_query("SET NAMES 'latin1'"); //OK // Default est en latin1 pour server en france si les tables sont en latin1
	mysql_query("SET NAMES 'utf8'"); //OK mais pas mettre de utf8 encode decode et les tables en utf8

//################################################################################################
	// ----------------------------- Login -------------------------------------------------------
		if($user_login != $_SESSION['userlogin'] || $passwd != $_SESSION['userpass'])	{
				session_unset();	//remove all the variables in the session
				include(FILENAME_DISPLAY_HEADER);
				?>
				<p>&nbsp;</p>
				<p>&nbsp;</p>
				<form action="<?php echo FILENAME_LOGIN; ?>" method="POST" name="login"><br />
				<table align="center" border="1" cellspacing="0" cellpadding="10">
				<tr><td>
					<table align="center" border="0" cellspacing="0" cellpadding="4">
					<tr>		
					<td><?php echo 'Login: '; ?></td><td><input name="userlogin" value="<?php echo $userlogin; ?>" type='text' maxlength='20' size='20'/></td></tr>
					<tr><td></td><td></td></tr>
					<tr><td><?php echo 'Password: ' ; ?></td><td><input name="userpass" value="<?php echo $userpass; ?>" type='password' maxlength='20' size='20'/></td></tr>
					<tr><td colspan="2" align="center"><input name="submitlogin" type="submit" value="OK"></td></tr>
					</table>
				</td></tr>
				</table>
				</form>
				<br><br><br><br>
				<table border="0" align="center" cellpadding="0" cellspacing="0">
				  <tr>
					<td align="center"><?php include(FILENAME_DISPLAY_FOOTER); ?></td>
				  </tr>
				</table>
				
				</body>
				</html>
				<?php
				exit;
		 }
######################################################################################################

include(FILENAME_DISPLAY_HEADER);

switch($type){
	case "test_jetlag": require(FILENAME_UTC_SERVER_TEST); break;
	case "add_crawler": require(FILENAME_ADD_CRAWLER); break;
	case "add_bad_user_agent": require(FILENAME_ADD_BAD_USER_AGENT) ;break;
	case "Allmystats_tools": require(FILENAME_ADMIN_TOOLS); break;
	case "MyVisitsTools": require(FILENAME_ADMIN_VISITS_TOOL); break;
	case "password": require(FILENAME_ADMIN_PASSW_TOOL); break;
	case "DetailsRobot": require(FILENAME_DETAILS_BOTS); break;
	case "cumul": require(FILENAME_MONTHLY_ARCHIVES_LIST); break;
	case "histo": require(FILENAME_HISTORY_MONTH_LIST); break;
	case "cumulpage": require(FILENAME_MONTHLY_ARCHIVES_EDIT); break;
	default: require(FILENAME_MAIN); break;
}
include(FILENAME_DISPLAY_FOOTER);
?>
</body>
</html>