<?php
/*
 -------------------------------------------------------------------------
 AllMyStats V1.59 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------
French
tats_in.php permet d'afficher publiquement les sections de vos statistiques souhaitées dans les pages de votre site web
Le cache de fichiers est déclenché par les visiteurs en fonction de la valeur de «$ time_update_cache". 
Cette solution ne recalcule pas chaque visiteur toutes les statistiques.

Un exemple d'utilisation est disponible dans:
/sample_stats_in/sample_stats_in_utf8.php
/sample_stats_in/sample_stats_in_iso.php
-----------------------------------------

English
stats_in.php allows the publicly display  the sections of your statistics desired in the pages of your website
The files cache is triggered by visitors according of value of "$time_update_cache". 
This solution does not recalculate every visitor all the statistics.

An example of usage is available in 
/sample_stats_in/sample_stats_in_utf8.php
/sample_stats_in/sample_stats_in_iso.php
*/

if (function_exists('error_reporting')) {
	error_reporting(E_ALL ^ E_NOTICE);
}

//######################################################## Configuration #######################################################################
	
	$public = false; 	//true pour accès public, si false --> Affiche Vous n'êtes pas autorisé à visiter cette section
						//true for public access, if false --> You are not allowed to visit this section

	$included_in_page_charset = 'iso-8859-1'; //utf-8, iso-8859-1 Charset des pages qui appellent stats_in
											  // charset pages that calls stats_in
											  
	$display_adword_links = true; //true --> Affiche les liens Adwords réseau de contenu si Google adwords est utilisé, false --> non affichés
								  //true -> Displays links AdWords content network if Google adwords is used, false -> not displayed
//----------------------------------- Colors style ------------------------------------------------------
	$txt_title = 'style="font-family: Verdana, Arial, sans-serif; font-weight: bold; font-size: 12px"';
	$txt_style = 'style="font-family: Verdana, Arial, sans-serif; font-size: 11px"';
	$td_style = 'style="font-family: Verdana, Arial, sans-serif; font-size: 10px"';
	$th_style = 'style="font-family: Verdana, Arial, sans-serif; font-size: 10px"';
	$table_border = 'style="border: 0px solid black; background-color: #000000; width: 570px"';
	$table_frame = 'style="border: 0px solid #000000; background-color: #99CCFF; width: 100%"';
	$table_data = 'style="background-color: #FAFAFA; width: 100%"';
	$table_title = 'style="font-family: Verdana, Arial, sans-serif; font-size: 14px; font-weight: bold; text-align:center; vertical-align:middle"';
	$page_view = 'style="color: #2000FF; font-family: Verdana, Arial, sans-serif; font-size: 10px; font-style: normal"';
	$style_visits = 'style="color: #8F0080; font-family: Verdana, Arial, sans-serif; font-size: 10px; font-style: normal"';
//------------------------------------------------------------------------------------------------------
//#############################################################################################################################################

	$html_body = false; //Si nouvelle page --> true - Si intégré dans une page existante --> false
						//If new page --> true - If integrated into an existing page --> false

//####################################################### DEPRECATED ##########################################################################
// Si stats_in.php est appelé directement par un simple lien vers stats_in.php, décommenter les lignes ci-dessous ( supprimer /* et */ )
// If the stats_in.php is called directly by a simple link to stats_in.php, uncomment the line below (remove / * and * /)
/*
$html_body = true; 					// Si nouvelle page --> true - Si intégré dans une page existante --> false - If new page --> true. If integrated into an existing page --> false
$display_graph_by_day = true;		// true ou false , affichage graphique: visiteurs & pages visitées/jour. Graphic display: visitors & page views / day
$display_keywords = true; 			// true ou false , affichage du tableau des mots clés (du mois en cours). Display tabbleau keywords (monthly)
$display_keywords_by_day = false;	// true ou false , affichage du tableau des mots clés du jour (du jour). Display tabbleau keywords (daily)
$display_top_keywords = 1000;		// Actif si $display_keywords ou $display_keywords_by_day = true. On if $display_keywords or $ display_keywords_by_day = true (max display keywords by referer)
$display_page_view = true; 			// true ou false , affichage du tableau pages visitées. true or false, table view page views
$display_org_geo = true; 			// true ou false , affichage du tableau origine géographique des visiteurs. Display tabbleau geographic origin of visitors
$display_operating_system = true;	// true ou false , affichage du tableau OS(Operating System) des visiteurs. table view OS (Operating System) of visitors
$display_browsers = true;			// true ou false , affichage du tabbleau Navigateurs utilisés par les visiteurs. view table Browsers used by visitors
$display_bots = true;				// true ou false , affichage du tabbleau des des visites robots. view table of visits robots.
$display_bad_user_agent = false; 	// Si true ne sera affiché que si au moins 1 bad user agent est détecté. If true would be displayed only if at least 1 bad user agent is detected
$time_update_cache = 15;			// Délai en minutes entre 2 mises à jour du fichier cache du mois en cours. Permet de ne pas charger les ressources serveur
									// Delay in minutes between 2 updates the cache file of the current month. Lets not load the server resources
*/
//#############################################################################################################################################
//#################################################################################################################################################

//dirname(__FILE__); //Path of file same if in include
require(dirname(__FILE__).'/config_allmystats.php');
require(dirname(__FILE__).'/includes/mysql_tables.php');
require(dirname(__FILE__).'/includes/languages/'.$langue.'/main.php');
require(dirname(__FILE__).'/includes/functions/general.php');
require(dirname(__FILE__).'/version.php');

		if(!$display_top_keywords) { $display_top_keywords = 1000; }
		
		mysql_connect($mysql_host,$mysql_login,$mysql_pass);
		mysql_select_db($mysql_dbnom);
		mysql_query("SET NAMES 'utf8'"); 

		$mois = trim(date('m/Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))))); 

		//#####################################################################################################
		$mois_Visualise = $mois;
		$Mois_Annee = explode("/", $mois_Visualise);
		$format_date_file_name = $Mois_Annee[1].'-'.$Mois_Annee[0];

		//---------- Construction du suffixe fichier cache -------------------
		$suffixe = "";
		if ($display_graph_by_day) {
		$suffixe .= "gd";
		}
		if ($display_keywords) {
		$suffixe .= "kw";
		}
		if ($display_keywords_by_day) {
		$suffixe .= "kwd";
		}
		if ($display_page_view) {
		$suffixe .= "pv";
		}
		if ($display_org_geo) {
		$suffixe .= "ge";
		}
		if ($display_operating_system) {
		$suffixe .= "os";
		}
		if ($display_browsers) {
		$suffixe .= "na";
		}
		if ($display_bots) {
		$suffixe .= "ro";
		}
		
		$cache_mois_in = "";


	if ($included_in_page_charset == 'iso-8859-1') {						
		$MsgNotAllowedThisSection = utf8_decode(MSG_NOT_ALLOWED_THIS_SECTION);
	} else { //utf-8
		$MsgNotAllowedThisSection = MSG_NOT_ALLOWED_THIS_SECTION;						
	} 

	if($public == false )	{
		echo '<br /><br /><center><strong>'.$MsgNotAllowedThisSection.'</strong></center><br />';
		exit;
	} else {
		if ( date('YmdHi') > date("YmdHi", @filemtime(dirname(__FILE__)."/cache/stats_in/stats_".$site."_".$format_date_file_name."-".$suffixe.".php")) + $time_update_cache || isset($archive_encours) ){
			//Todo mise en cache
			$action_cache_mois_in = true;
			msg_temporaire('<p align="center" id="cache"><strong><big><font color="#FF0000">'.MSG_OPERATION_IN_PROGRESS.'</font></big></strong></p>');
			echo '<div align="center" '.$txt_title.'>'.MSG_WEBSITE_STATISTICS.' '.$site.' - '.MSG_MONTH." ".$mois_Visualise.'</div><div align="center">'.MSG_LAST_UPDATE.' '.date('d/m/Y - H:i').'</div>';
		} else {
			//Pas de mise en cache à faire
			$action_cache_mois_in = false;
			echo '<center>'.MSG_LAST_UPDATE.' '.date('d/m/Y - H:i', filemtime(dirname(__FILE__).'/cache/stats_in/stats_'.$site.'_'.$format_date_file_name.'-'.$suffixe.'.php')).'</center>' ; //Date de dèrnière mise à jour du fichier
			include_once(dirname(__FILE__)."/cache/stats_in/stats_".$site."_".$format_date_file_name."-".$suffixe.".php");
		}
	}
		//-------------------------------------------------------------------
		//############################################################# End init ###########################################

if ($action_cache_mois_in) {

/*
				//--------- Pour éviter de lancer le script par plusieurs visiteurs ------------
				 $nbSlashes = substr_count($_SERVER['SCRIPT_NAME'], '/'); // on compte le nombre total de slashes contenu dans le lien relatif du fichier courant
				 $nbSlashes --; // on ne compte pas le slash de la racine (placé au début du lien relatif)
				 $root_site = ''; // on initialise la remontée dans l'arborescence
				 for($i = 0; $i < $nbSlashes; $i++)
				 {
					 $root_site .= '../';
				 }
				//---------------------------------------
				//Supprime 1er "/" de $path_allmystats_abs Important si $root_site = ""
				$path_allmystats_rel = substr($path_allmystats_abs, 1);
				$Fnm = $root_site.$path_allmystats_rel."cache/stats_in/stats_".$site."_".$format_date_file_name."-".$suffixe.".php";
*/					
				$Fnm = dirname(__FILE__)."/cache/stats_in/stats_".$site."_".$format_date_file_name."-".$suffixe.".php";

				//$time = time() - 30; //ajoute 30 seconde //date du fichier = + 30 secondes à la date actuelle 
				@touch($Fnm); // modifie date du fichier sur la date actuelle
				//-----------------------------------------------------------------------------

	// -------------------------------------- Affichage -----------------------------------------------------------------------
	$show_footer = '<div align="center" '.$txt_style.'><a href="http://allmystats.wertronic.com" target="_blank">AllMyStats '.VERSION.'</a> Powered by <a href="http://www.wertronic.com" target="_blank">Wertronic</a></div><br />';
	$show_cumul_page = $show_footer;

	//###################################################################################################################
	//										GRAPH PAR JOUR
	//###################################################################################################################
if ($display_graph_by_day) {

	//Hauteur graph
	$height_graph = 180.00; // dans boucle pour plus de clarté

	$total_nb_pages_visitees = "";
	$max_pages = "";
	$result = mysql_query("select visited_pages, sum(visited_pages) as total_visited_page from ".TABLE_DAYS_PAGES." where date like '%".$mois."' GROUP BY date");
	while($row = mysql_fetch_array($result)){ //while sur nb jour
		if($row['total_visited_page'] > $max_pages){
			$max_pages = $row['total_visited_page']; // Pour chaque jour
		}
		$total_nb_pages_visitees = $total_nb_pages_visitees + $row['total_visited_page'];
	}

	$result = mysql_query("select * from ".TABLE_UNIQUE_VISITOR." where date like '%".$mois."'");
	$total_nb_visiteurs = mysql_num_rows($result);

$graph_byday .= "
<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
  <tr>
    <td ".$td_style.">
      <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
        <tr>
          <th ".$table_title.">"
		  	.MSG_GRAPH_MONTH_VISITORS_PAGES." (".MSG_EXCLUDED_BOTS.") - ".$mois."
		  </th>
          </tr>
        <tr>
          <td colspan=\"2\" ".$td_style.">
		  	<small>".MSG_TOTAL_VISITORS." = ".$total_nb_visiteurs."<br />
			".MSG_TOTAL_PAGES_VISITED." = ".$total_nb_pages_visitees."</small>
            <table border=\"0\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
              <tr>
          		<td rowspan=\"2\" ".$td_style.">
					<b><span ".$page_view.">".MSG_VISITED_PAGES."</span><br />
					&amp; 
		  			<span ".$style_visits.">".MSG_VISITORS."</span></b>
		  		</td>";
				
				//Pour affichage echelle y
				if($max_pages != 0){
					echo $row['visited_pages']."<br>";
					$indice_echelle = 1; $hauteur = bcmul($indice_echelle, $height_graph, 2);
					if ($MaxHauteur_echelle <= $hauteur) { $MaxHauteur_echelle = $hauteur; $EchyMin = '0'; }
				} else { // pour ne pas afficher 0 si $max_pages = 0
					$EchyMin  = '';	
					$max_pages = '';
				}

$graph_byday .= "
		  	<td nowrap=\"nowrap\" valign=\"top\" ".$td_style.">".$max_pages."</td>
		  	<td rowspan=\"2\" valign=\"bottom\" ".$td_style."><img src=\"".$path_allmystats_abs."images/histo-v_black.gif\" height=\"".$MaxHauteur_echelle."\" width=\"1\" alt=\"y\" title=\"y\"/></td>";

			unset($val_jour);
			$result = mysql_query("select date, sum(visitors) as total_visitors_day, sum(visited_pages) as total_visited_page_day from ".TABLE_DAYS_PAGES." where date like '%".$mois."' GROUP BY date");
			while($row = mysql_fetch_array($result)){ //while sur nb jour

				$date_comp = $row['date'];
				$cpt_jour = substr($date_comp, 0, 2) + 0; // + 0 pour faire disparaitre les 0 devant 01, 02, 03 etc (aussi simple qu'une regex)

				$result_uniq_visits = mysql_query("select date from ".TABLE_UNIQUE_VISITOR." where date='".$row['date']."'");

				$val_jour[$cpt_jour][0] = mysql_num_rows($result_uniq_visits);
				$val_jour[$cpt_jour][1] = $row['total_visited_page_day'];

				$graph_byday .= "<td rowspan=\"2\" valign=\"bottom\" ".$td_style.">";
				if($max_pages != 0) {
					$indice = bcdiv($val_jour[$cpt_jour][1], $max_pages,2); $hauteur = bcmul($indice, $height_graph, 2);
				}
				$graph_byday .= "<img src=\"".$path_allmystats_abs."images/histo-v.gif\" height=\"".$hauteur."\" width=\"7\" alt=\"".$val_jour[$cpt_jour][1]."\" title=\"".$val_jour[$cpt_jour][1]."\"/>";

				if($max_pages!=0){
					$indice = bcdiv($val_jour[$cpt_jour][0], $max_pages, 2); $hauteur = bcmul($indice, $height_graph, 2);  
				}
				$graph_byday .=  "<img src=\"".$path_allmystats_abs."images/histo-vv.gif\" height=\"".$hauteur."\" width=\"7\" alt=\"".$val_jour[$cpt_jour][0]."\" title=\"".$val_jour[$cpt_jour][0]."\"/></td>";

			}

$graph_byday .= "
		  </tr>
		  <tr>
			 <td align=\"right\" valign=\"bottom\" ".$td_style.">".$EchyMin."</td>
		  </tr>
		  
              <tr>
                <td ".$td_style."><b>". MSG_GRAPH_DAY."</b></td>

 	    <td align=\"center\" ".$td_style.">&nbsp;</td><td align=\"center\" ".$td_style.">&nbsp;</td>"; // Pour echelle x
		
		//----------------- calcul jour du mois et week end pour echelle x ------------------------
		$jm = explode("/",$mois);
		$nbjourdumois = maxDaysInMonth($jm[0], $jm[1]);
		
		// Premier samedi du mois (6eme jour de la semaine) fonction get_first_day
		$premiersamedi =  strftime("%d", get_first_day(6, $jm[0], $jm[1])); 
		$weekend = "/";
		if ($premiersamedi == 7) { $weekend .= sprintf("%02d",1).'|'; } //Le 1er jour du mois est un dimanche
		for($i = $premiersamedi; $i <= $nbjourdumois; $i=$i+7){
			$week = $i;
			$week = $week+0;
			$weekend .= sprintf("%02d",$week).'|'; 
			$weekend .= sprintf("%02d",$week+1) .'|';
		}
		$weekend = substr($weekend, 0, strlen($weekend)-1); //supp last |
		$weekend .= "/";
		//------------------ Affichage echelle x -----------------
		for($i = 1; $i <= $nbjourdumois; $i++){
			$num = $i;
			if(!preg_match($weekend, sprintf("%02d", $num))) {	//$num+0 pour supprimer les 0 devant 01, 02 ,03 etc
		  		$graph_byday .=  "<td align=\"center\" ".$td_style.">". sprintf("%02d", $num)."</td>";
		  	} else {
		  		$graph_byday .= "<td align=\"center\" ".$td_style."><b><font color=\"#990000\">". sprintf("%02d", $num)."</font></b></td>";
			}
		}
		//---------------------------------------------------------------------------------------

$graph_byday .= "
						</tr>
					</table>
				</td></tr>
			</table>
		</td></tr>
	</table><br />";

		 $show_cumul_page .= $graph_byday;
		 $graph_byday ="";

	//--------------------------------------------------------------------------------------------
} // End if ($display_graph_by_day) {

	//############################################################################################
	//									KEYWORDS MONTHLY
	//############################################################################################	

	if ($display_keywords) {

		//Total different keywords
		$total_keywors = mysql_query("select COUNT(*) from ".TABLE_MONTHLY_KEYWORDS." where date='".$mois."' and keyword<>'TOTAL_VISITS'");
		$total_differents_keyword = mysql_fetch_row($total_keywors); 

		$show_cumul_page .= "
		<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
		  <tr>
			<td ".$td_style.">
			  <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
				<tr>
				  <th ".$table_title.">Top".$display_top_keywords."<br />".MSG_REFERERS_AND_KEYWORDS.' '.$mois."<br /><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_KEYWORDS.": ".$total_differents_keyword[0]."</font></small></th>
				  </tr>
				<tr>
				  <td colspan=\"2\" ".$td_style.">
					<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
					  <tr>
						<th ".$th_style.">". MSG_REFERERS."</th>
						<th ".$th_style.">". MSG_KEYWORDS."</th>
						<th ".$th_style.">". MSG_VISITORS."</th>
					  </tr>";
		// referer (unique) tri par keyword='TOTAL_VISITS'
		$referer = mysql_query("select host_referer, keyword, nb_item from ".TABLE_MONTHLY_KEYWORDS." where date='".$mois."' and keyword='TOTAL_VISITS'");
		unset($Tab_referer);
		unset($tri_Tab_aff_ref);

		while($row = mysql_fetch_array($referer)){
			$Tab_referer[] = $row['host_referer'];
		}

		//lecture keywords, nb_item, Nb different keywords / referer
		for($i = 0; $i < count($Tab_referer); $i++){ 
			$result = mysql_query("select keyword, nb_item from ".TABLE_MONTHLY_KEYWORDS." where host_referer='".$Tab_referer[$i]."' and date='".$mois."' order by nb_item DESC");
			$nb_keywords_diff = mysql_num_rows($result); //Nb different keywords
			while($row = mysql_fetch_array($result)){
				if($row['keyword']=='TOTAL_VISITS') {
					$tri_Tab_aff_ref[] = array($row['nb_item'], $Tab_referer[$i], $row['keyword'], $nb_keywords_diff); //dans ce sens car on trie sur nb visites
				} 
			}
		}
		@array_multisort($tri_Tab_aff_ref,SORT_DESC);
		for($i = 0; $i < count($tri_Tab_aff_ref); $i++){
			$distinct_keyword_count = intval($tri_Tab_aff_ref[$i][3])-1; // -1 car TOTAL_VISITS est compté
			$result = mysql_query("select keyword, nb_item from ".TABLE_MONTHLY_KEYWORDS." where host_referer='".trim($tri_Tab_aff_ref[$i][1])."' and date='".$mois."' ORDER BY nb_item DESC, keyword ASC LIMIT ".$display_top_keywords."");

			//-----------------------------
			//Longueur Affichage Referer
			$lenmax=35;
			if (strlen($tri_Tab_aff_ref[$i][1])>$lenmax) {
				$chaine1=substr($tri_Tab_aff_ref[$i][1], 0, $lenmax);
				$chaine2=substr($tri_Tab_aff_ref[$i][1], $lenmax);
				$tri_Tab_aff_ref[$i][1] = $chaine1."<br />".$chaine2;
			}
			//-----------------------------

			$show_cumul_page .= "
			<tr>
			  <td align=\"left\" valign=\"top\" ".$td_style.">
			  	".$tri_Tab_aff_ref[$i][1]."
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">";
			    if ($distinct_keyword_count<>0) {
					$show_cumul_page .= '<span>'.MSG_DIFFERENTS.': '. $distinct_keyword_count .'</span><br />';
				} else {
					$show_cumul_page .= "&nbsp;";
				}
				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						if ($included_in_page_charset == 'iso-8859-1') {						
							if (!strstr($row['keyword'],'googlesyndication=1')) {
								if (strlen($row['keyword']) > 65) { $row['keyword']=substr($row['keyword'], 0, 65).'...'; }
								$show_cumul_page .= "<span><font color='#990000'>".(utf8_decode($row['keyword']))."</span><br>"; 					
							} else { // (Adwords Réseau de Contenu)
								if($display_adword_links) {
									$aff_referer = utf8_decode($row['keyword']);
									$aff_referer = str_replace("?googlesyndication=1", '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$aff_referer = str_replace('&googlesyndication=1', '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$link = $aff_referer;
									if (strlen($aff_referer.strip_tags(MSG_ADWORDS_CONTENT_NETWORK)) > 50) { $aff_referer=substr($aff_referer, 0, 30).'...'; }
									$show_cumul_page .= "<a href=\"$link\" target=\"_new\">".(urldecode($aff_referer))."</a><font color=#666666>&nbsp;&nbsp;".MSG_ADWORDS_CONTENT_NETWORK."</font><br>";
								} else {
									$show_cumul_page .= MSG_ADWORDS_CONTENT_NETWORK.'<br>';
								}
							}
						} else { //utf-8
							if (!strstr($row['keyword'],'googlesyndication=1')) {
								if (mb_strlen($row['keyword'],'utf-8') > 65) { $row['keyword']=mb_substr($row['keyword'], 0, 65,'utf-8').'...'; } //mb_ pour utf8
								$show_cumul_page .= "<span><font color='#990000'>".($row['keyword'])."</span><br>"; 					
							} else { // (Adwords Réseau de Contenu)
								if($display_adword_links) {
									$aff_referer = utf8_decode($row['keyword']);
									$aff_referer = str_replace("?googlesyndication=1", '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$aff_referer = str_replace('&googlesyndication=1', '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$link = $aff_referer;
									if (mb_strlen($aff_referer.strip_tags(MSG_ADWORDS_CONTENT_NETWORK),'utf-8') > 50) { $aff_referer=mb_substr($aff_referer, 0, 30,'utf-8').'...'; }
									$show_cumul_page .= "<a href=\"$link\" target=\"_new\">".(urldecode($aff_referer))."</a><font color=#666666>&nbsp;&nbsp;".MSG_ADWORDS_CONTENT_NETWORK."</font><br>";
								} else {
									$show_cumul_page .= MSG_ADWORDS_CONTENT_NETWORK.'<br>';								
								}
							}
						} 
					}
				}
			$show_cumul_page .= "
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
			    Total: ".$tri_Tab_aff_ref[$i][0]."<br />";
				
				@mysql_data_seek($result, 0); // reset($result);
				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						$show_cumul_page .= "<span><font color=\"#990000\">".$row['nb_item']."</font></span><br />";
					}
				}

			$show_cumul_page .= "
			  </td>
			 </tr>";
		}

		$show_cumul_page .= "</table></td></tr>
			  </table></td></tr></table><br />" ;

	unset($Tab_referer);
	unset($tri_Tab_aff_ref);

	} // End if ($display_keywords ) {


	//############################################################################################
	//								KEYWORDS BY DAY
	//############################################################################################	

	if ($display_keywords_by_day) {
		
		$day = date('d/m/Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
		
		//Total different keywords
		$total_keywors = mysql_query("select COUNT(*) from ".TABLE_DAYS_KEYWORDS." where date='".$day."' and keyword<>'TOTAL_VISITS'");
		$total_differents_keyword = mysql_fetch_row($total_keywors); 
	
		$show_cumul_page .= "
		<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
		  <tr>
			<td ".$td_style.">
			  <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
				<tr>
				  <th ".$table_title.">Top".$display_top_keywords."<br />".MSG_REFERERS_AND_KEYWORDS.' '.$day."<br /><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_KEYWORDS_DAY.": ".$total_differents_keyword[0]."</font></small></th>
				  </tr>
				<tr>
				  <td colspan='2' ".$td_style.">
					<table border='1' cellpadding='2' cellspacing='0' ".$table_data.">
					  <tr>
						<th ".$th_style.">".MSG_REFERERS."</th>
						<th ".$th_style.">".MSG_KEYWORDS."</th>
						<th ".$th_style.">".MSG_VISITORS."</th>
					  </tr>";
		// referer (unique) tri par keyword='TOTAL_VISITS'
		$referer = mysql_query("select host_referer, keyword, nb_item from ".TABLE_DAYS_KEYWORDS." where date='".$day."' and keyword='TOTAL_VISITS'");
		unset($Tab_referer);
		unset($tri_Tab_aff_ref);

		while($row = mysql_fetch_array($referer)){
			$Tab_referer[] = $row['host_referer'];
		}

		//lecture keywords, nb_item, Nb different keywords / referer
		for($i = 0; $i < count($Tab_referer); $i++){ 
			$result = mysql_query("select keyword, nb_item from ".TABLE_DAYS_KEYWORDS." where host_referer='".$Tab_referer[$i]."' and date='".$day."' order by nb_item DESC");
			$nb_keywords_diff = mysql_num_rows($result); //Nb different keywords
			while($row = mysql_fetch_array($result)){
				if($row['keyword']=='TOTAL_VISITS') {
					$tri_Tab_aff_ref[] = array($row['nb_item'], $Tab_referer[$i], $row['keyword'], $nb_keywords_diff); //dans ce sens car on trie sur nb visites
				} 
			}
		}
		@array_multisort($tri_Tab_aff_ref,SORT_DESC);
		for($i = 0; $i < count($tri_Tab_aff_ref); $i++){
			$distinct_keyword_count = intval($tri_Tab_aff_ref[$i][3])-1; // -1 car TOTAL_VISITS est compté
			$result = mysql_query("select keyword, nb_item from ".TABLE_DAYS_KEYWORDS." where host_referer='".trim($tri_Tab_aff_ref[$i][1])."' and date='".$day."' ORDER BY nb_item DESC, keyword ASC LIMIT ".$display_top_keywords."");

			//-----------------------------
			//Longueur Affichage Referer
			$lenmax=35;
			if (strlen($tri_Tab_aff_ref[$i][1])>$lenmax) {
				$chaine1 = substr($tri_Tab_aff_ref[$i][1], 0, $lenmax);
				$chaine2 = substr($tri_Tab_aff_ref[$i][1], $lenmax);
				$tri_Tab_aff_ref[$i][1] = $chaine1."<br />".$chaine2;
			}
			//-----------------------------

			$show_cumul_page .= "
			<tr>
			  <td align=\"left\" valign=\"top\" ".$td_style.">
			  	".$tri_Tab_aff_ref[$i][1]."
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">";
			    if ($distinct_keyword_count<>0) {
					$show_cumul_page .= '<span>'.MSG_DIFFERENTS.': '. $distinct_keyword_count .'</span><br>';
				} else {
					$show_cumul_page .= "&nbsp;";
				}

				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						if ($included_in_page_charset == 'iso-8859-1') {						
							if (!strstr($row['keyword'],'googlesyndication=1')) {
								if (strlen($row['keyword']) > 65) { $row['keyword']=substr($row['keyword'], 0, 65).'...'; }
								$show_cumul_page .= "<span><font color='#990000'>".(utf8_decode($row['keyword']))."</span><br>"; 					
							} else { // (Adwords Réseau de Contenu)
								if($display_adword_links) {
									$aff_referer = utf8_decode($row['keyword']);
									$aff_referer = str_replace("?googlesyndication=1", '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$aff_referer = str_replace('&googlesyndication=1', '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$link = $aff_referer;
									if (strlen($aff_referer.strip_tags(MSG_ADWORDS_CONTENT_NETWORK)) > 50) { $aff_referer=substr($aff_referer, 0, 30).'...'; }
									$show_cumul_page .= "<a href=\"$link\" target=\"_new\">".(urldecode($aff_referer))."</a><font color=#666666>&nbsp;&nbsp;".MSG_ADWORDS_CONTENT_NETWORK."</font><br>";
								} else {
									$show_cumul_page .= MSG_ADWORDS_CONTENT_NETWORK.'<br>';
								}
							}
						} else { //utf-8
							if (!strstr($row['keyword'],'googlesyndication=1')) {
								if (mb_strlen($row['keyword'],'utf-8') > 65) { $row['keyword']=mb_substr($row['keyword'], 0, 65,'utf-8').'...'; } //mb_ pour utf8
								$show_cumul_page .= "<span><font color='#990000'>".($row['keyword'])."</span><br>"; 					
							} else { // (Adwords Réseau de Contenu)
								if($display_adword_links) {
									$aff_referer = utf8_decode($row['keyword']);
									$aff_referer = str_replace("?googlesyndication=1", '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$aff_referer = str_replace('&googlesyndication=1', '', $aff_referer); //Ne fonctionne pas avec le $row['keyword'] directement
									$link = $aff_referer;
									if (mb_strlen($aff_referer.strip_tags(MSG_ADWORDS_CONTENT_NETWORK),'utf-8') > 50) { $aff_referer=mb_substr($aff_referer, 0, 30,'utf-8').'...'; }
									$show_cumul_page .= "<a href=\"$link\" target=\"_new\">".(urldecode($aff_referer))."</a><font color=#666666>&nbsp;&nbsp;".MSG_ADWORDS_CONTENT_NETWORK."</font><br>";
								} else {
									$show_cumul_page .= MSG_ADWORDS_CONTENT_NETWORK.'<br>';								
								}
							}
						} 
					}
				}
			$show_cumul_page .= "
			  </td>
			  <td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
			    Total: ".$tri_Tab_aff_ref[$i][0]."<br />";
				
				@mysql_data_seek($result, 0); // reset($result);
				while($row = mysql_fetch_array($result)){
					if($row['keyword'] <> 'TOTAL_VISITS') {
						$show_cumul_page .= "<span><font color=\"#990000\">".$row['nb_item']."</font></span><br />";
					}
				}

			$show_cumul_page .= "
			  </td>
			 </tr>";
		}

		$show_cumul_page .= "</table></td></tr>
			  </table></td></tr></table><br />" ;

	unset($Tab_referer);
	unset($tri_Tab_aff_ref);

	} // End if ($display_keywords_by_day ) {


	//############################################################################################
	//						Pages visitées
	//############################################################################################
if ($display_page_view) {
		
	$result = mysql_query("select count(*) as nb_diff_pages, sum(visited_pages) as total_pages from ".TABLE_DAYS_PAGES." where date like '%".$mois."'");
	$row = mysql_fetch_array($result);
	$pages_cumul = $row['total_pages']; // Total Pages

	$result = mysql_query("select pages_name, sum(visitors) as total_visitors, sum(visited_pages) as total_pages from ".TABLE_DAYS_PAGES." where date like '%".$mois."' GROUP BY pages_name order by total_pages DESC, pages_name ASC");
	$differents_pages = mysql_num_rows($result); // Pages différentes
		
	$show_cumul_page .= "
	<table align=\"center\" cellpadding=\"1\" cellspacing='0' ".$table_border.">
	  <tr>
		<td ".$td_style.">
		  <table cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
			<tr>
			  <th ".$table_title.">". MSG_VISITED_PAGES." (".MSG_EXCLUDED_BOTS.")".$mois."<br><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_PAGES.": ".$differents_pages."</small></font></th>
			  </tr>
	
			<tr>
			  <td colspan=\"2\" ".$td_style.">
				<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
				  <tr>
					<th ".$th_style.">".MSG_PAGE."</th>
					<th ".$th_style.">".MSG_VISITORS."</th>
					<th ".$th_style.">".MSG_VISITED_PAGES."</th>
					<th ".$th_style.">".MSG_PAGES_PERCENTAGE."</th>
				  </tr>";
	
				while($row=mysql_fetch_array($result)){
					$nb = $row['total_pages']*100; 
					if($pages_cumul != 0){
						$percents = bcdiv($nb, intval($pages_cumul), 2);
				}

				if ($included_in_page_charset == 'iso-8859-1') {						
					$charset_pages_name = utf8_decode($row['pages_name']);
				} else { //utf-8
					$charset_pages_name = $row['pages_name'];						
				} 

				$show_cumul_page .= "<tr><td ".$th_style.">".$charset_pages_name."</td><td align=\"center\" ".$th_style.">".$row['total_visitors']."</td><td align=\"center\" ".$th_style.">".$row['total_pages']."</td><td align=\"center\" ".$th_style.">".$percents."%</td></tr>";
			}
	
		$show_cumul_page .= "
		</table></td></tr></table></td></tr></table><br />";

	} // End de if ($display_page_view) {	
	

			//############################################################################################
			//						ORIGINE GEO MONTH
			//############################################################################################
		if ($display_org_geo) {
				
			//ORG GEO
			if(!function_exists('geoip_open')) { //To avoid Fatal error: Cannot redeclare geoip_load_shared_mem() (previously declared in page)
				require_once(dirname(__FILE__).'/lib/geoip/geoip.inc');
			}
			if(!function_exists('geoip_country_name_by_code')) { //if geoip.inc previously declared in page but not geoip_add.inc (add for AllMySats)
				require_once(dirname(__FILE__).'/lib/geoip/geoip_add.inc');
			}

			$handle = geoip_open(dirname(__FILE__)."/lib/geoip/dat/GeoIP.dat", GEOIP_STANDARD);

			$result = mysql_query("select count(country) as visitors_by_country, sum(visits) as pages_by_country, country from ".TABLE_UNIQUE_VISITOR." where date like '%".$mois."' GROUP BY country ORDER BY visitors_by_country DESC");
			$total_differents_countries = mysql_num_rows($result);
							
			$result_max_pages = mysql_query("select sum(visits) as pages_by_country from ".TABLE_UNIQUE_VISITOR." where date like '%".$mois."' GROUP BY country ORDER BY pages_by_country DESC");
			$row_max_pages = mysql_fetch_array($result_max_pages); //Car on tri mintenant sur lrs visiteurs donc 1er pas obligatoirement OK
			$indice = @bcdiv(1, ($row_max_pages['pages_by_country']/200), 3); //proportion en rapport au plus grand nb de pages visités
		
		$show_cumul_page .= "
			<table align=\"center\" cellpadding=\"1\" cellspacing=\"0\" ".$table_border.">
			  <tr>
				<td ".$td_style.">
				  <table align=\"center\" cellpadding=\"5\" cellspacing=\"0\" ".$table_frame.">
					<tr>
					  <th ".$table_title.">".MSG_TITLE_ORG_GEO." (".MSG_EXCLUDED_BOTS.")<br><small><font style=\"font-weight:lighter\">".MSG_TOTAL_DIFFERENT_COUNTRIES.": ".$total_differents_countries."</font><small></TH>
					</tr>
					<tr>
					  <td colspan=\"2\" ".$td_style.">
						<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" ".$table_data.">
						  <tr>
							<th ".$th_style.">".MSG_COUNTRY."</th>
							<th ".$th_style.">".MSG_NB_VISITORS."</th>
							<th ".$th_style.">".MSG_VISITED_PAGES."</th>
						  </tr>";
		
					@mysql_data_seek($result, 0); //reset($result) to 0;
					while($row = mysql_fetch_array($result)){
						if ($row['country'] == '') { 
							if ($included_in_page_charset == 'iso-8859-1') {						
								$Country = utf8_decode(MSG_ORIGIN_UNKNOWN);
							} else { //utf-8
								$Country = $row['country'];						
							} 
						} else {
							//Country flags
							$record_code = geoip_country_name_by_code($handle, $row['country']); // Function ajouté dans geoip.inc
			
							if ($included_in_page_charset == 'iso-8859-1') {						
								$charset_country_name = utf8_decode($row['country']);
							} else { //utf-8
								$charset_country_name = $row['country'];						
							} 

							if (file_exists(dirname(__FILE__)."/images/flags/".strtolower($record_code).".png")) { 
								$Country = "<img src=\"".$path_allmystats_abs."images/flags/".strtolower($record_code).".png\" height=\"10\" width=\"14\" alt=\"".$charset_country_name."\" title=\"".$charset_country_name."\"> ".$charset_country_name;
							} else {
								$Country = $charset_country_name;
							}
						}
						
		$show_cumul_page .= "<tr>
						<td nowrap=\"nowrap\" ".$td_style.">  
							<b>".$Country."</b>
						</td>
						<td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
							<img src=\"".$path_allmystats_abs."images/histo-h.gif\" width=\""; 
							$hauteur = bcmul($row['visitors_by_country'] , $indice, 2);  
		$show_cumul_page .= $hauteur . "\" height=\"8\" alt=\"".$row['visitors_by_country']."\" title=\"".$row['visitors_by_country']."\">".$row['visitors_by_country'].
						"</td>
						<td nowrap=\"nowrap\" align=\"left\" ".$td_style.">
							<img src=\"".$path_allmystats_abs."images/histo-h.gif\" width=\"";
							$hauteur = bcmul($row['pages_by_country'], $indice, 2);  
		$show_cumul_page .= $hauteur."\" height=\"8\" alt=\"".$row['pages_by_country']."\" title=\"".$row['pages_by_country']."\">".$row['pages_by_country'].
						"</td>";	
					}
					
					@geoip_close($handle); //GEOIP n'est plus appelé après --> on ferme $handle
							
		
		$show_cumul_page .= '</table></td></tr></table></td></tr></table><br />';
		
		
		} // End if ($display_org_geo) {


		//############################################################################################
		//			display_operating_system display_browsers display_bad_user_agent
		//############################################################################################

	if($display_operating_system || $display_browsers || $display_bad_user_agent){
		require_once("includes/filename.php");
		$dislpay_button_tool_bots = "false"; //Important "false" entre guillemets car affiche le bouton si  $dislpay_button_tool_bots = "";
		?>
		<table width="90%" border="0" align="center">
		  <tr>
			<td align="center"><?php  
				$when_date = $mois; // date d/m/Y or m/Y
				include(dirname(__FILE__).'/'.FILENAME_DISPLAY_OS_BROWSER);	 
				$show_cumul_page .= $show_page_os_nav_robots;
				?>
			</td>
		  </tr>
		</table>
		<?php
	}
		//############################################################################################
		//			display_bots
		//############################################################################################
			if ($display_bots == true) {	
				$dislpay_button_tool_bots = "false"; //Important "false" entre guillemets car affiche le bouton si  $dislpay_button_tool_bots = "";
					?>
					<table width="90%" border="0" align="center">
					  <tr>
						<td align="center">
							<?php  
							$when_date = $mois;
							include_once('display_bots.php'); //Calcul et affichage des tableaux
							$show_cumul_page .= $show_page_os_nav_robots;
							?>
						</td>
					  </tr>
					</table>
					<?php
			}
		//###############################################################################################
		//########################################## AFFICHAGE ##########################################
		
			echo $show_cumul_page;	// Affichage des tableaux

			message($msg , "");		//efface le message Patientez
	
			//--------- Footer -------------------
			echo $show_footer;
			//------------------------------------					

		//###############################################################################################	
		//###############################################################################################
		
	########################################## Mise en cache du mois encours actuel #######################################
	
			$mois_actuelle = date('m/Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			$mois_Visualise = $mois;
		
			$Mois_Annee_visualise = explode("/", $mois_Visualise);
			$mois_visualise = $Mois_Annee_visualise[0]; // mois
			$annee_visualise = $Mois_Annee_visualise[1]; //année
			
			$Mois_Annee_actuelle = explode("/", $mois_actuelle);
			$mois_actuelle = $Mois_Annee_actuelle[0];
			$annee_actuelle = $Mois_Annee_actuelle[1];
	
			if ($action_cache_mois_in || isset($archive_encours) ) { //on met en cache
			
				if (!is_dir(dirname(__FILE__)."/cache")) {
					mkdir (dirname(__FILE__)."/cache");
				}

				if (!is_dir(dirname(__FILE__)."/cache/stats_in")) {
					mkdir (dirname(__FILE__)."/cache/stats_in");
				}

				
				$Mois_Annee = explode("/", $mois_Visualise);
				$format_date_file_name = $Mois_Annee[1].'-'.$Mois_Annee[0];
				
				$Fnm = dirname(__FILE__)."/cache/stats_in/stats_".$site."_".$format_date_file_name."-".$suffixe.".php";

				if (!$inF = @fopen($Fnm,"w")){
					echo "Erreur create file<br />";
				}

				if ($html_body) {
					$page_html = 
		'<?php
		//###############################################################################################
		//					Read Protection
		//###############################################################################################
		//Si le fichier est hors du répertoire cache et se trouve dans un répertoire quelconque du site
		// Accès public par défaut
		if (is_dir(dirname(__FILE__)."/cache")) { // On test les droits d\'accès au fichier
			require (dirname(__FILE__)."/config_allmystats.php");
	
			if(!$public)	{
				echo "<br /><br /><center><strong>".$MsgNotAllowedThisSection."</center></strong><br />";
				exit;
			}
		}
		//###############################################################################################
		//###############################################################################################
		?>
					
						<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 						"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
						<html xmlns="http://www.w3.org/1999/xhtml">
						<head>
						<title>AllMyStats - '. $site.' - '.$format_date_file_name.'</title>
				
						<style type="text/css">
						<!--
						.StyleBleuClair {color: #006DB7}
						.NoirMoyen {font-size: 120%; color: #333333; }
						.plop {
						   text-decoration: blink;
						}
						.Noirclair {
							color: #2D2D2D;
							font-weight: bold;
						}
						.Style41 {color: #003C64; font-size: 110%; }
						.Style63 {color: #009900}
						.Style65 {color: #003C64; font-size: 110%; font-weight: bold; }
						.Style61 {color: #006600;
							font-weight: bold;
						}
						.Style56 {font-size: 14px;
							color: #002779;
							font-weight: bold;
						}
						-->
						</style>
						<meta http-equiv="Content-Type" content="text/html; charset=utf-8"></head>
						<body>
							<table align="center" width="100%" border="0">
								<tr>
									<td align="center" '.$txt_title.'>'.MSG_WEBSITE_STATISTICS.' '.$site." - ".MSG_MONTH." ".$mois_Visualise.'<br /><br /></td>
								</tr>
								<tr>
									<td align="center">'.$show_cumul_page . $show_footer.'</td>
								</tr>
							</table>
						</body></html>';
				} else {
					$page_html = 
		'<?php
		//###############################################################################################
		//					Read Protection
		//###############################################################################################
		//Si le fichier est hors du répertoire cache et se trouve dans un répertoire quelconque du site
		// Accès public par défaut
		if (is_dir(dirname(__FILE__)."/cache")) { // On test les droits d\'accès au fichier
			require (dirname(__FILE__)."/config_allmystats.php");
	
			if(!$public)	{
				echo "<br /><br /><center><strong>".$MsgNotAllowedThisSection."</center></strong><br />";
				exit;
			}
		}
		//###############################################################################################
		//###############################################################################################
		?>
				
						<table width="100%" border="0" align="center">
							<tr>
								<td align="center" '.$txt_title.'>'.MSG_WEBSITE_STATISTICS.' '.$site." - Mois: ".$mois_Visualise.'<br /><br /></td>
							</tr>
							<tr>
								<td align="center">'.$show_cumul_page . $show_footer.'</td>
							</tr>
							</table>';
				}

				if(!@fwrite($inF,$page_html)){
					echo "Erreur write file<br />";
				}

				if(!@fclose($inF)){
					echo "Erreur close file";
				}

			} //End if ($action_cache_mois_in || isset($archive_encours) )

} // End if ($action_cache_mois_in) {

//-------------------------------------------------------------------------------------------
//#################################################################################################
//										Functions
//#################################################################################################

function msg_temporaire ($temp_msg) {
 	flush();
 	echo $temp_msg; ?>
	<script type="text/javascript">
	document.getElementById("cache").style.visibility = "visible";
	</script><?php
 	flush();
}
 
function message($msg, $title){ ?> 
	<script type="text/javascript">
 		document.getElementById("cache").style.visibility = "hidden";
	</script><?php
}

function copy_dir($dir_to_copy,$dir_paste) {
	// On vérifie si $dir_to_copy est un dossier
	if (is_dir($dir_to_copy)) {
		// Si oui, on l'ouvre
		if ($dh = opendir($dir_to_copy)) {     
			// On liste les dossiers et fichiers de $dir_to_copy
			while (($file = readdir($dh)) !== false) {
				// Si le dossier dans lequel on veut coller n'existe pas, on le créé
				if (!is_dir($dir_paste)) {
					mkdir ($dir_paste, 0777);
				}
						   
				// S'il s'agit d'un dossier, on relance la fonction récursive
				if(is_dir($dir_to_copy.$file) && $file != '..'  && $file != '.') {				
					copy_dir ( $dir_to_copy.$file.'/' , $dir_paste.$file.'/' );
				} elseif ($file != '..'  && $file != '.') { // S'il sagit d'un fichier, on le copue simplement
					copy ( $dir_to_copy.$file , $dir_paste.$file );
				}
			}
			// On ferme $dir_to_copy
			closedir($dh);
		}
	}       
}

?>
