<?php
/*
 -------------------------------------------------------------------------
 AllMyStats V1.59 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------

Note:
Les mots clés ne sont enregistrés seulement pour les nouveaux visiteurs, 
si un visiteur revient dans la même journée par un moteur de recherche le nouveau mot clé ne sera pas pris en compte
http://geolite.maxmind.com/download/geoip/database/GeoLiteCountry/GeoIP.dat.gz
*/

	if (function_exists('error_reporting')) {
		error_reporting(E_ALL ^ E_NOTICE);
	}

	require(dirname(__FILE__).'/config_allmystats.php');
 	require(dirname(__FILE__).'/includes/mysql_tables.php');
	require(dirname(__FILE__).'/includes/filename.php');
	require_once(dirname(__FILE__).'/includes/functions/'.FILENAME_SEARCH_ENGINE);
	require_once(dirname(__FILE__).'/includes/functions/cyr_charset_autodetect.php');

	if ($HTTP_COOKIE_VARS["AllMyStatsVisites"] == 'No record this') {
		echo $Flag_Exclus_by_cookie;
		return;
	}

	//TODO TABLE specific for this
	$very_bad_agent = '/<\?|<script>/i'; // drop this user agent --> inject Cross-Site Scripting

	$remote_adrr_ip = $_SERVER['REMOTE_ADDR']; 
	//$remote_adrr_ip = '92.46.80.205'; //92.46.80.205, 92.46.80.206, ....
	// The correction is made below if geoip.inc already loaded but with an older version that contains the error: Kazakstan for Kazakhstan

	//--------------- Ip non comptabilisées ------------------------- 
 	$Tab_element_Ip = explode(".",$remote_adrr_ip);

 	for($i = 0; $i < count($IpExlues); $i++){
		$Tab_element_IpEx = explode(".",$IpExlues[$i]);
		$Nb = count($Tab_element_IpEx);

		for ($Ni = 0; $Ni < count($Tab_element_IpEx); $Ni++) {
			if (trim($Tab_element_IpEx[$Ni])) { 
				$Ip_a_tester .= $Tab_element_Ip[$Ni].'.';
			} else { //si . et rien
				$IpExlues[$i] = substr($IpExlues[$i],0,strlen($IpExlues[$i])-1);
			}
		}
		$Ip_a_tester = substr($Ip_a_tester,0,strlen($Ip_a_tester)-1);

		if(@stristr($IpExlues[$i], $Ip_a_tester)) {
			echo $Flag_Exclus_by_IP;
			return;
		}
		
		$Ip_a_tester ='';
	}
 
//------------------------------------------------------------------------------------------------------------
	mysql_connect($mysql_host,$mysql_login,$mysql_pass) or die("Connexion à la base de données impossible");
	mysql_select_db($mysql_dbnom);
	mysql_query("SET NAMES 'utf8'"); 
	
	if($nom_page == ""){ $nom_page = basename($_SERVER['SCRIPT_NAME']); }
	//La page qui appelle peut être en utf-8 ou iso-8859-1, avec codage é ou &eacute;
	//si cp1251 cyrillic exclusif ou ascii mais les accents ne seront pas pris
	//Si utf-8 iso-8859-1, cyrillic mixed OK
	$prepare_nom_page = str_replace(" ","",$nom_page);   // for test charset no space else error on cp1251 and cp1251 must be first and only cyrillic caractères 
	$encode = mb_detect_encoding($prepare_nom_page, "cp1251,UTF-8,iso-8859-1");
	if($encode<>'UTF-8') {
		$nom_page = mb_convert_encoding($nom_page,"UTF-8",$encode);
	}

	$date = date('d/m/Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
	$heure = date('H:i',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
	$jour = "$date%";

	//########################################################################################################################################
	//---------------- Mise en en forme ($AllBots) pour preg_match --------------------------------------
	// bot connus (dans la table + bot en générale (bot, spider , etc)
	$result1 = mysql_query("select bot_name from ".TABLE_CRAWLER." "); 
	$AllBots = '/Bot|Slurp|Scooter|Spider|crawl|';
	
	while($row=mysql_fetch_array($result1)){
		$Form_chaine = str_replace('/','\/',$row['bot_name']);
		$Form_chaine = str_replace('+','\+',$Form_chaine);
		$Form_chaine = str_replace('(','\(',$Form_chaine);
		$Form_chaine = str_replace(')','\)',$Form_chaine);
		$AllBots .= $Form_chaine.'|';
	}
	$AllBots = substr($AllBots, 0, strlen($AllBots)-1); //supp last |
	$AllBots .= '/i';
	//---------------------------------------------------------------------------------------------------

	//----- Chaîne bad user agent et agents inconnus ----------------------------------------------------
	$Bad_User_Agent = mysql_query("select * from ".TABLE_BAD_USER_AGENT.""); 

	while($bad_agents = mysql_fetch_array($Bad_User_Agent)){ // Mise en tableau des bads agent
		$All_bad_user_agent .= "+-+".$bad_agents['user_agent'];
	}
	$All_bad_user_agent .= '+-+';
	//---------------------------------------------------------------------------------------------------

	//###########################################################################################################################################
	
	//Table Cumule pages mensuel
	$mois = date('m/Y', strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));

	#####################################################################################################
		//Ajout du test de agent car par exemple Googlebot, Googlebot-Image sur même IP (pour affichage des robots).
		//Note: si un visiteur vient de la même IP mais avec un navigateur différent une visite sera compté, mais c'est même mieux.
		//Certains user agents comportent plus de 255 caractères et donc agent = n'est pas OK => multiple visites pour un seul
//$result = mysql_query("select * from ".TABLE_UNIQUE_VISITOR." where date like '".$jour."' and ip='".$remote_adrr_ip."' and agent='".substr($_SERVER['HTTP_USER_AGENT'], 0, 255)."'");

// Since MySQL new tables, it's not necessary Googlebot, Googlebot-Image on same IP count 2 visitors - for the same IP, counting one visitor.
$result = mysql_query("select * from ".TABLE_UNIQUE_VISITOR." where date like '".$jour."' and ip='".$remote_adrr_ip."'");

$row = mysql_fetch_array($result);

if (strpos($All_bad_user_agent, '+-+'.$row['agent'].'+-+') === false) { // ou peut être $_SERVER['HTTP_USER_AGENT'] replace $row['agent']

	if(!preg_match($AllBots, ($_SERVER['HTTP_USER_AGENT']))) { 

		if ($row['code'] <> ""){ //Ce visiteur est déjà passé aujourd'hui
			
			@mysql_query("update ".TABLE_UNIQUE_VISITOR." set visits=visits+1 where code='".$row['code']."'");
	
			$verif = @mysql_query("select * from ".TABLE_PAGE_VISITOR." where code='".$row['code']."' and page='".$nom_page."'");
			$verif_row = @mysql_fetch_array($verif); //seul warning possible sur cette ligne et quand ?

			if ($verif_row['page'] <> ""){ //Ce visiteur est déjà passé aujourd'hui ET la page a déjà été visitée
				$requete = "update ".TABLE_PAGE_VISITOR." set visits=visits+1 where code='".$row['code']."' and page='".$nom_page."'";
				mysql_query($requete);
				//-------------------------- TABLE_DAYS_PAGES -----------------------------
				//$visited_pages
				$requete = "update ".TABLE_DAYS_PAGES." set visited_pages=visited_pages+1 where pages_name='".$nom_page."' and date='".$date."'";
				@mysql_query($requete);
			} else { //Ce visiteur est déjà passé aujourd'hui ET visite une nouvelle page (pour aujourd'hui)
				mysql_query("insert into ".TABLE_PAGE_VISITOR." values ('".$row['code']."','".$nom_page."','1','".$heure."')");
				//-------------------------- TABLE_DAYS_PAGES -----------------------------
				//EN TEST car ... ???
				$result = @mysql_query("select visited_pages from ".TABLE_DAYS_PAGES." where pages_name='".$nom_page."' and date='".$date."'"); 
				$row_day = @mysql_fetch_array($result);
				if ($row_day['visited_pages']) {					
					$requete = "update ".TABLE_DAYS_PAGES." set visitors=visitors+1, visited_pages=visited_pages+1 where pages_name='".$nom_page."' and date='".$date."'";
					@mysql_query($requete);
				} else {
					$sql_day_pages = "insert into ".TABLE_DAYS_PAGES." (date, pages_name, visitors, visited_pages) values('".$date."','".$nom_page."','1','1');";
					@mysql_query($sql_day_pages);  
				}
			}
		
		} else { // ---------------------------------------- VISITEUR -------------------------------------------------------------------
	
			// détermination du code permettant la jointure entre la table visiteur et page
			$result= mysql_query("select max(code) as cd from ".TABLE_UNIQUE_VISITOR.""); 
		
			$dateY = date('Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			$dateM = date('m',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			if($last_code = mysql_fetch_array($result)){
				$the_last = $last_code['cd'];
				$anneemois = substr($the_last,0,4)."/".substr($the_last,4,2);
				$verif_date = date('Y/m',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
		
				if($anneemois == $verif_date){
					//sera auto incrémente par la table MySQL 
					$cp = ""; 
				} else {
					$cp = $dateY.$dateM."00000001"; // est fixé et ne sera pas auto incremente par la table MySQL
				}
			} else {
				$cp = $dateY.$dateM."00000001";
			}
			
			if (@gethostbyaddr($remote_adrr_ip)) {
				$reverse_dns = gethostbyaddr($remote_adrr_ip);
			} else {
				$reverse_dns = "No reverse dns response";
			}
		
			//------------------------ Détermination du pays ------------------------------------------
			if(!function_exists('geoip_open')) { //To avoid Fatal error: Cannot redeclare geoip_load_shared_mem() (previously declared in if in page
				require_once(dirname(__FILE__).'/lib/geoip/geoip.inc');
			}
			/*
			if(!function_exists('geoip_country_name_by_code')) { //Normally not required here but ... - if geoip.inc previously declared in page but not geoip_add.inc (add for AllMySats) 
				require_once(dirname(__FILE__).'/lib/geoip/geoip_add.inc');
			}
			*/
			$handle = geoip_open(dirname(__FILE__)."/lib/geoip/dat/GeoIP.dat", GEOIP_STANDARD);
			$record_name = geoip_country_name_by_addr($handle,$remote_adrr_ip);
			@geoip_close($handle);

			if ($record_name){ 
				if($record_name == 'Kazakstan') { $record_name = 'Kazakhstan'; } // if geoip.inc already loaded, but with an older version that contains the error: Kazakstan for Kazakhstan
				$country = $record_name; 
			}
		
			//-----------------------------------------------------------------------------------------
			//-----------------------------------------------------------------------------------------
			//If googlesyndication && &go= n'est pas reperable adwords avec redirection
			//ex:http://googleads.g.doubleclick.net/pagead/ads?client=ca-pub-284680014599&dt=1229857649&lmt=1228954495&output=html&slotname=21389625&correlator=1229841799&url=http%3A%2F%2Fwww.diamonotv.com
			
			//Pour Google syndication et googleads.g.doubleclick.net
			if (strstr($_SERVER['HTTP_REFERER'],'googlesyndication.com') || strstr($_SERVER['HTTP_REFERER'],'googleads.g.doubleclick.net')) {	
				$syndic = $_SERVER['HTTP_REFERER'];
				$Url_syndication = explode('&url=',$syndic);
				$Url_syndication = explode('&',$Url_syndication[1]);
		
				$Referer = urldecode($Url_syndication[0]);
				//Pour Google syndication
				if (strstr($Referer,'?')) { // si ? existe déjà mettre &
					$Referer = urldecode($Url_syndication[0]). '&googlesyndication=1'; 
				} else {
					$Referer = urldecode($Url_syndication[0]). '?googlesyndication=1';		
				}
		
			} else { //Normal - Pas Google syndication
				$Referer = urldecode($_SERVER['HTTP_REFERER']);

				################################################################################################################
				//USED decoding entire url
				$Referer = cyr_detect_convert_string_to($Referer, 'utf-8');	//Detect and convert UTF8,cp1251,KOI8-R to UTF-8 
				################################################################################################################

			}
			//------------------------------------------
			
			if(!preg_match($very_bad_agent, $_SERVER['HTTP_USER_AGENT'])) {	
	
					//-------------------- Format l'url pour images.google -----------------
					if (strstr($Referer,'images.google') <> '') {
						$url   = parse_url($Referer);
						$query = $url["query"];
						$host  = $url["host"];
						parse_str($query);
						$Referer = "http://".$host.trim(($prev)); // Lien vers l'image. Note: $prev est dans l'url de Google
						$reverse_dns = $host; //et on met images.google.tld
					}
					//----------------------------------------------------------------------
		
					// Si new $cp est définit plus haut, sinon auto incremente par la table
					$sql1 = "insert into ".TABLE_UNIQUE_VISITOR." values('".$_SERVER['HTTP_USER_AGENT']."','".$Referer."','".$remote_adrr_ip."','".$date."','".$reverse_dns."','".$cp."','".$country."','1');";
					$result = mysql_query($sql1) or die('Erreur 1 SQL! '.$sql1.'<br>'.mysql_error());  
		
					$result = mysql_query("select max(code) as cd from ".TABLE_UNIQUE_VISITOR."");
					$last_code = mysql_fetch_array($result);
					$sql = "insert into ".TABLE_PAGE_VISITOR." values ('".$last_code['cd']."','".$nom_page."','1','".$heure."');";
					$result = mysql_query($sql) or die('Erreur  2 SQL! '.$sql.'<br>'.mysql_error()); 
		
					//------------------------- TABLE_DAYS_PAGES ---------------------------
					//Visiteur nouveau --> page déjà vue aujourd'hui ?
					$result = @mysql_query("select visited_pages from ".TABLE_DAYS_PAGES." where pages_name='".$nom_page."' and date='".$date."'"); 
					$row_day = @mysql_fetch_array($result);
					if ($row_day['visited_pages']) {					
						$requete = "update ".TABLE_DAYS_PAGES." set visitors=visitors+1, visited_pages=visited_pages+1 where pages_name='".$nom_page."' and date='".$date."'";
						@mysql_query($requete);
					} else {
						$sql_day_pages = "insert into ".TABLE_DAYS_PAGES." (date, pages_name, visitors, visited_pages) values('".$date."','".$nom_page."','1','1');";
						@mysql_query($sql_day_pages);  
					}
					//----------------------------------------------------------------------
					//#################################################################################################################
					//--------------- Extraction Keyword et Referers - Update table monthly 
					$parse_referer = parse_url($Referer);
					$host_referer = $parse_referer['host'];
					$Keyword = trim(MotsCles($Referer, $host_referer)); 	//... Pour les adwords l'url est trouvée car dans visiteur.php est ajouté au referer $Referer = urldecode($Url_syndication[0]). '?googlesyndication=1' ou '&googlesyndication=1';

		##########################################################################################
					//----------------------------
	
					if( $Keyword <> 'TOTAL_VISITS') { //'TOTAL_VISITS' car au cas où visitor inject keyword = 	TOTAL_VISITS
						if (!$host_referer) { // si referer - on comptabilise aussi les referers dans la table (tjrs 'TOTAL_VISITS') 					
							$host_referer = 'Unknown or direct';
						}
						//--------------------------------------------------------------------------
						//Daily - Test par 'TOTAL_VISITS' si ce referer est déjà présent pour aujourd'hui dans la table 
						$result = @mysql_query("select nb_item from ".TABLE_DAYS_KEYWORDS." where host_referer='".$host_referer."' and keyword='TOTAL_VISITS' and date='".$date."'"); 
						$row_item_day = @mysql_fetch_array($result);
						
						if(!$row_item_day['nb_item']) { //Ce referer n'existe pas pour aujourd'hui --> Insert ce nouveau referer
							$sql_day_keywords = "insert into ".TABLE_DAYS_KEYWORDS." (date, host_referer, keyword, nb_item) values('".$date."','".$host_referer."','TOTAL_VISITS','1');";
							@mysql_query($sql_day_keywords); 
							
							if($Keyword) { //Si l'url contient un keyword --> Insert le 1er keyword pour ce referer 
								$sql_monthly_keywords = "insert into ".TABLE_DAYS_KEYWORDS." (date, host_referer, keyword, nb_item) values('".$date."','".$host_referer."','".($Keyword)."','1');";
								@mysql_query($sql_monthly_keywords); 
							}
						} else { //Ce referer exist déjà
							
							$result = @mysql_query("select nb_item from ".TABLE_DAYS_KEYWORDS." where host_referer='".$host_referer."' and keyword='".($Keyword)."' and date='".$date."'"); 
							$row_item_day = @mysql_fetch_array($result);
							if($row_item_day['nb_item']) {
								// +1 sur nb_item pour ce referer et ce TOTAL_VISITS
								$requete = "update ".TABLE_DAYS_KEYWORDS." set nb_item=nb_item+1 where host_referer='".$host_referer."' and keyword='TOTAL_VISITS' and date='".$date."'";
								@mysql_query($requete);
	
								if($Keyword) { //si keyword non vide --> +1 sur nb_item pour ce referer et ce keyword 
									$requete = "update ".TABLE_DAYS_KEYWORDS." set nb_item=nb_item+1 where host_referer='".$host_referer."' and keyword='".($Keyword)."' and date='".$date."'";
									@mysql_query($requete);
								}
							} else { //Nouveau keyword pour ce referer
								// +1 sur nb_item pour ce referer et ce TOTAL_VISITS
								$requete = "update ".TABLE_DAYS_KEYWORDS." set nb_item=nb_item+1 where host_referer='".$host_referer."' and keyword='TOTAL_VISITS' and date='".$date."'";
								@mysql_query($requete);
								
								if($Keyword) { // Insert le nouveau keyword
									$sql_monthly_keywords = "insert into ".TABLE_DAYS_KEYWORDS." (date, host_referer, keyword, nb_item) values('".$date."','".$host_referer."','".($Keyword)."','1');";
									@mysql_query($sql_monthly_keywords); 
								}
							}
						} // end if(!preg_match($AllBots, $_S
						//--------------------------------------------------------------------------
	
						//Monthly - Test par 'TOTAL_VISITS' si ce referer est déjà présent pour ce mois dans la table 
						$result = @mysql_query("select nb_item from ".TABLE_MONTHLY_KEYWORDS." where host_referer='".$host_referer."' and keyword='TOTAL_VISITS' and date='".$mois."'"); 
						$row_monthly_keyword = @mysql_fetch_array($result);
						
						if(!$row_monthly_keyword['nb_item']) { //Ce referer n'existe pas --> Insert ce nouveau referer
							$sql_monthly_keywords = "insert into ".TABLE_MONTHLY_KEYWORDS." (date, host_referer, keyword, nb_item) values('".$mois."','".$host_referer."','TOTAL_VISITS','1');";
							@mysql_query($sql_monthly_keywords); 
							
							if($Keyword) { //Si l'url contient un keyword --> Insert le 1er keyword pour ce referer 
								$sql_monthly_keywords = "insert into ".TABLE_MONTHLY_KEYWORDS." (date, host_referer, keyword, nb_item) values('".$mois."','".$host_referer."','".($Keyword)."','1');";
								@mysql_query($sql_monthly_keywords); 
							}
						} else { //Ce referer exist déjà
							
							$result = @mysql_query("select nb_item from ".TABLE_MONTHLY_KEYWORDS." where host_referer='".$host_referer."' and keyword='".($Keyword)."' and date='".$mois."'"); 
							$row_monthly_keyword = @mysql_fetch_array($result);
							if($row_monthly_keyword['nb_item']) {
								// +1 sur nb_item pour ce referer et ce TOTAL_VISITS
								$requete = "update ".TABLE_MONTHLY_KEYWORDS." set nb_item=nb_item+1 where host_referer='".$host_referer."' and keyword='TOTAL_VISITS' and date='".$mois."'";
								@mysql_query($requete);
	
								if($Keyword) { //si keyword non vide --> +1 sur nb_item pour ce referer et ce keyword 
									$requete = "update ".TABLE_MONTHLY_KEYWORDS." set nb_item=nb_item+1 where host_referer='".$host_referer."' and keyword='".($Keyword)."' and date='".$mois."'";
									@mysql_query($requete);
								}
							} else { //Nouveau keyword pour ce referer
								// +1 sur nb_item pour ce referer et ce TOTAL_VISITS
								$requete = "update ".TABLE_MONTHLY_KEYWORDS." set nb_item=nb_item+1 where host_referer='".$host_referer."' and keyword='TOTAL_VISITS' and date='".$mois."'";
								@mysql_query($requete);
								
								if($Keyword) { // Insert le nouveau keyword
									$sql_monthly_keywords = "insert into ".TABLE_MONTHLY_KEYWORDS." (date, host_referer, keyword, nb_item) values('".$mois."','".$host_referer."','".($Keyword)."','1');";
									@mysql_query($sql_monthly_keywords); 
								}
							}
						}
					} // End if( $Keyword <> 'TOTAL_VISITS')
					//-----------------------------------------------------------------


			} // if(!preg_match($very_bad_agent, $_SERVER['HTTP_US

		} // END if ($row['code'] <> ""){ //Ce visiteur est déjà passé aujourd'hui
						
	} else { // END if(!preg_match($AllBots, $_SERVER['HTTP_USE --> ###################################### BOT BOT BOT ###############################################

		//Ajout du test de agent car par exemple Googlebot, Googlebot-Image sur même IP (pour affichage des robots).
		//Certains user agents comportent plus de 255 (512 if varchar(512)) caractères et donc agent = n'est pas OK => multiple visites pour un seul
		$result = mysql_query("select * from ".TABLE_UNIQUE_BOT." where date like '".$jour."' and ip='".$remote_adrr_ip."' and agent='".substr($_SERVER['HTTP_USER_AGENT'], 0, 512)."'");
		$row = mysql_fetch_array($result);

		if ($row['code'] <> ""){ //Ce bot est déjà passé aujourd'hui
	
			@mysql_query("update ".TABLE_UNIQUE_BOT." set visits=visits+1 where code='".$row['code']."'");
	
			$verif = @mysql_query("select * from ".TABLE_PAGE_BOT." where code='".$row['code']."' and page='".$nom_page."'");
			$verif_row = @mysql_fetch_array($verif); //seul warning possible sur cette ligne et quand ?

			if ($verif_row['page'] <> ""){ //Ce bot est déjà passé aujourd'hui ET la page a déjà été visitée
				$requete = "update ".TABLE_PAGE_BOT." set visits=visits+1 where code='".$row['code']."' and page='".$nom_page."'";
				mysql_query($requete);
			} else { //Ce bot est déjà passé aujourd'hui ET visite une nouvelle page (pour aujourd'hui)
				mysql_query("insert into ".TABLE_PAGE_BOT." values ('".$row['code']."','".$nom_page."','1','".$heure."')");
			}
		
		} else { // ---------------------------------------- BOT NOUVEAU -------------------------------------------------------------------
	
			// détermination du code permettant la jointure entre la TABLE_UNIQUE_BOT et TABLE_PAGE_BOT
			$result= mysql_query("select max(code) as cd from ".TABLE_UNIQUE_BOT.""); 
		
			$dateY = date('Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			$dateM = date('m',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			if($last_code = mysql_fetch_array($result)){
				$the_last = $last_code['cd'];
				$anneemois = substr($the_last,0,4)."/".substr($the_last,4,2);
				$verif_date = date('Y/m',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
		
				if($anneemois == $verif_date){
					//sera auto incrémente par la table MySQL 
					$cp = ""; 
				} else {
					$cp = $dateY.$dateM."00000001"; // est fixé et ne sera pas auto incremente par la table MySQL
				}
			} else {
				$cp = $dateY.$dateM."00000001";
			}
			
			if (@gethostbyaddr($remote_adrr_ip)) {
				$reverse_dns = gethostbyaddr($remote_adrr_ip);
			} else {
				$reverse_dns = "No reverse dns response";
			}

			//------------------------ Détermination du pays ------------------------------------------
			if(!function_exists('geoip_open')) { //To avoid Fatal error: Cannot redeclare geoip_load_shared_mem() (previously declared in if in page
				require_once(dirname(__FILE__).'/lib/geoip/geoip.inc');
			}
			/*
			if(!function_exists('geoip_country_name_by_code')) { //Normally not required here but ... - if geoip.inc previously declared in page but not geoip_add.inc (add for AllMySats) 
				require_once(dirname(__FILE__).'/lib/geoip/geoip_add.inc');
			}
			*/
			$handle = geoip_open(dirname(__FILE__)."/lib/geoip/dat/GeoIP.dat", GEOIP_STANDARD);
			$record_name = geoip_country_name_by_addr($handle, $remote_adrr_ip);
			@geoip_close($handle);
			
			if ($record_name){ 
				if($record_name == 'Kazakstan') { $record_name = 'Kazakhstan'; } // if geoip.inc already loaded, but with an older version that contains the error: Kazakstan for Kazakhstan
				$country = $record_name; 
			}
			//-----------------------------------------------------------------------------------------
				
			$Referer = urldecode($_SERVER['HTTP_REFERER']); //decode add 07-05-2010

			//------------------------------------------
			$very_bad_agent = '/<\?|<script>/i'; // drop this user agent --> inject
			
			if(!preg_match($very_bad_agent, $_SERVER['HTTP_USER_AGENT'])) {
	
				// Si new $cp est définit plus haut, sinon auto incremente par la TABLE_UNIQUE_BOT
				$sql1 = "insert into ".TABLE_UNIQUE_BOT." values('".$_SERVER['HTTP_USER_AGENT']."','".$Referer."','".$remote_adrr_ip."','".$date."','".$reverse_dns."','".$cp."','".$country."','1');";
				$result = mysql_query($sql1) or die('Erreur 1 SQL! '.$sql1.'<br>'.mysql_error());  
		
				$result = mysql_query("select max(code) as cd from ".TABLE_UNIQUE_BOT."");
				$last_code = mysql_fetch_array($result);
				$sql = "insert into ".TABLE_PAGE_BOT." values ('".$last_code['cd']."','".$nom_page."','1','".$heure."');";
				$result = mysql_query($sql) or die('Erreur  2 SQL! '.$sql.'<br>'.mysql_error()); 
			}	
		}
	}

} else { ############################## EST UN BAD USER AGENT OR UNKOWN mais non vide #######################################

	$Bad_User_Agent_query = mysql_query("select * from ".TABLE_BAD_USER_AGENT." where user_agent='".substr($_SERVER['HTTP_USER_AGENT'], 0, 255)."'"); 
	$Bad_User_Agent = mysql_fetch_array($Bad_User_Agent_query);
	$type = $Bad_User_Agent['type'];

		$result = mysql_query("select * from ".TABLE_UNIQUE_BAD_AGENT." where date like '".$jour."' and ip='".$remote_adrr_ip."' and agent='".substr($_SERVER['HTTP_USER_AGENT'], 0, 255)."'");
		$row = mysql_fetch_array($result);

		if ($row['code'] <> ""){ //Ce visiteur utilisant ce bad user agent est déjà passé aujourd'hui
	
			@mysql_query("update ".TABLE_UNIQUE_BAD_AGENT." set visits=visits+1 where code='".$row['code']."'");
	
			$verif = @mysql_query("select * from ".TABLE_PAGE_BAD_AGENT." where code='".$row['code']."' and page='".$nom_page."'");
			$verif_row = @mysql_fetch_array($verif); 

			if ($verif_row['page'] <> ""){ //Ce visiteur utilisant ce bad user agent ET la page a déjà été visitée
				$requete = "update ".TABLE_PAGE_BAD_AGENT." set visits=visits+1 where code='".$row['code']."' and page='".$nom_page."'";
				mysql_query($requete);
			} else { //Ce visiteur est déjà passé aujourd'hui ET visite une nouvelle page (pour aujourd'hui)
				mysql_query("insert into ".TABLE_PAGE_BAD_AGENT." values ('".$row['code']."','".$nom_page."','1','".$heure."')");
			}
		
		} else { // ---------------------------------------- VISITEUR BAD USER AGENT NOUVEAU -------------------------------------------------------------------
	
			// détermination du code permettant la jointure entre la TABLE_PAGE_BAD_AGENT et TABLE_PAGE_BAD_AGENT
			$result= mysql_query("select max(code) as cd from ".TABLE_UNIQUE_BAD_AGENT.""); 
		
			$dateY = date('Y',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			$dateM = date('m',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
			if($last_code = mysql_fetch_array($result)){
				$the_last = $last_code['cd'];
				$anneemois = substr($the_last,0,4)."/".substr($the_last,4,2);
				$verif_date = date('Y/m',strtotime($UTC." hours", strtotime(date("Y-m-d H:i:s"))));
		
				if($anneemois == $verif_date){
					//sera auto incrémente par la table MySQL 
					$cp = ""; 
				} else {
					$cp = $dateY.$dateM."00000001"; // est fixé et ne sera pas auto incremente par la table MySQL
				}
			} else {
				$cp = $dateY.$dateM."00000001";
			}
			
			if (@gethostbyaddr($remote_adrr_ip)) {
				$reverse_dns = gethostbyaddr($remote_adrr_ip);
			} else {
				$reverse_dns = "No reverse dns response";
			}
		
			//------------------------ Détermination du pays ------------------------------------------
			//http://geolite.maxmind.com/download/geoip/api/php/ChangeLog --> 1.8	2009-04-02	* Fixed spelling of Kazakhstan, was Kazakstan
			if(!function_exists('geoip_open')) { //To avoid Fatal error: Cannot redeclare geoip_load_shared_mem() (previously declared in if in page
				require_once(dirname(__FILE__).'/lib/geoip/geoip.inc');
			}
			/*
			if(!function_exists('geoip_country_name_by_code')) { //Normally not required here but ... - if geoip.inc previously declared in page but not geoip_add.inc (add for AllMySats) 
				require_once(dirname(__FILE__).'/lib/geoip/geoip_add.inc');
			}
			*/
			$handle = geoip_open(dirname(__FILE__)."/lib/geoip/dat/GeoIP.dat", GEOIP_STANDARD);
			$record_name = geoip_country_name_by_addr($handle,$remote_adrr_ip);
			@geoip_close($handle);

			if ($record_name){ 
				if($record_name == 'Kazakstan') { $record_name = 'Kazakhstan'; } // if geoip.inc already loaded, but with an older version that contains the error: Kazakstan for Kazakhstan
				$country = $record_name; 
			}
			//-----------------------------------------------------------------------------------------
				$Referer = urldecode($_SERVER['HTTP_REFERER']); //decode add 07-05-2010

			//------------------------------------------
			
			if(!preg_match($very_bad_agent, $_SERVER['HTTP_USER_AGENT'])) {	
					// Si new $cp est définit plus haut, sinon auto incremente par la table
					$sql1 = "insert into ".TABLE_UNIQUE_BAD_AGENT." values('".$_SERVER['HTTP_USER_AGENT']."','".$type."', '".$Referer."','".$remote_adrr_ip."','".$date."','".$reverse_dns."','".$cp."','".$country."','1');";
					$result = mysql_query($sql1) or die('Erreur 1 SQL! '.$sql1.'<br>'.mysql_error());  
		
					$result = mysql_query("select max(code) as cd from ".TABLE_UNIQUE_BAD_AGENT."");
					$last_code = mysql_fetch_array($result);
					$sql = "insert into ".TABLE_PAGE_BAD_AGENT." values ('".$last_code['cd']."','".$nom_page."','1','".$heure."');";
					$result = mysql_query($sql) or die('Erreur  2 SQL! '.$sql.'<br>'.mysql_error()); 
			}
					//----------------------------------------------------------------------
	} //End } else { //---------- VISITEUR NOUVEAU --
			//#################################################################################################################

} // End } else { // EST UN BAD USER AGENT OR UNKOWN mais non vide
	
	
	//################################################# END ######################################################################

//mysql_close();


?>