<?php
/*
 -------------------------------------------------------------------------
 AllMyStats V1.59 - Statistiques, audience de site web
 -------------------------------------------------------------------------
 Copyright (C) 2008 - Herve Seywert
 -------------------------------------------------------------------------
 Web:    http://allmystats.wertronic.com - http://www.wertronic.com
 -------------------------------------------------------------------------
 copyright-GNU-xx.txt
 -------------------------------------------------------------------------
*/

function CompareValeurs($val1, $val2) {
	if ($val2[1] == $val1[1])
		return(strcmp($val1[0],$val2[0]));
	else
		return($val2[1] - $val1[1]);
}


/**
* Fonction retournant le nombre de jours dans un mois.
* @param integer $month Mois de 1 à 12
* @param integer $year Année
* @return integer Nombre de jours
*/
function maxDaysInMonth($month, $year) {
	if( function_exists( "cal_days_in_month" )) {
	  $days = cal_days_in_month(CAL_GREGORIAN, $month, $year);
	  return $days;
	} else {
	  //if not compile PHP with support for calendars
	  return $days == 2 ? ($year % 4 ? 28 : ($year % 100 ? 29 : ($year % 400 ? 28 : 29))) : (($month - 1) % 7 % 2 ? 30 : 31);
	}
}

  /**
   *
   *  Gets the first weekday of that month and year
   *
   *  @param  int   The day of the week (0 = sunday, 1 = monday ... , 6 = saturday)
   *  @param  int   The month (if false use the current month)
   *  @param  int   The year (if false use the current year)
   *
   *  @return int   The timestamp of the first day of that month
   *
   **/ 
  function get_first_day($day_number=1, $month=false, $year=false)
  {
    $month  = ($month === false) ? strftime("%m"): $month;
    $year   = ($year === false) ? strftime("%Y"): $year;
   
    $first_day = 1 + ((7+$day_number - strftime("%w", mktime(0,0,0,$month, 1, $year)))%7);
 
    return mktime(0,0,0,$month, $first_day, $year);
  }

	//--------------------------------------------------------------------
	// Server - bcmath not installed
	//If you don't have bcmath installed and you need to use bcdiv() with a defined precision / scale you may need this function:
	if( !function_exists( "bcdiv" )) {
		function bcdiv( $first, $second, $scale = 0 ) {
			if ($second <> 0 ) {
				$res = $first / $second;
				return round( $res, $scale );
			}
		}
	}
	
	//if you have compiled php width "--disable-bcmath", you can use this:
	if( !function_exists( "bcmul" )) {
	  function bcmul($_ro, $_lo, $_scale=0) {
		return round($_ro*$_lo, $_scale);
	  }
	}
	//--------------------------------------------------------------------

/* Delete direcory recursif */
function delete_directory($dir) { 
 	  $current_dir = opendir($dir); 
 	  
 	  while($entryname = readdir($current_dir)) { 
		   if(is_dir("$dir/$entryname") and ($entryname != "." and $entryname!="..")) { 
				delete_directory("${dir}/${entryname}"); 
		   } elseif ($entryname != "." and $entryname!="..") { 
				unlink("${dir}/${entryname}"); 
		   } 
 	  } 
 	  
 	  closedir($current_dir); 
 	  rmdir(${dir}); 
} 


?>
