-- phpMyAdmin SQL Dump
-- version 2.9.1.1-Debian-13
-- http://www.phpmyadmin.net
-- Version du serveur: 5.0.32
-- Version de PHP: 5.2.0-8+etch16

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_archive`
-- 

CREATE TABLE `allmystats_archive` (
  `annee` int(11) NOT NULL default '0',
  `mois` int(11) NOT NULL default '0',
  `visiteur` int(11) NOT NULL default '0',
  `visite` int(11) NOT NULL default '0',
  `visites_hors_bot` int(11) NOT NULL default '0',
  `pages_hors_bot` int(11) NOT NULL default '0',
  `visites_robot` int(11) NOT NULL default '0',
  `pages_robots` int(11) NOT NULL default '0',
  PRIMARY KEY  (`annee`,`mois`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_bad_user_agent`
-- 

CREATE TABLE `allmystats_bad_user_agent` (
  `id` int(5) NOT NULL auto_increment,
  `user_agent` varchar(255) NOT NULL default '',
  `info` varchar(255) NOT NULL default '',
  `type` char(1) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_crawler`
-- 

CREATE TABLE `allmystats_crawler` (
  `id_crawler` smallint(5) unsigned NOT NULL auto_increment,
  `crawler_user_agent` varchar(255) default NULL,
  `org_name` varchar(45) NOT NULL default '',
  `bot_name` varchar(45) default NULL,
  `crawler_url` varchar(255) default NULL,
  `crawler_info` varchar(255) default NULL,
  `crawler_ip` varchar(16) default NULL,
  PRIMARY KEY  (`id_crawler`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_days_keywords`
-- 

CREATE TABLE `allmystats_days_keywords` (
  `id` int(11) NOT NULL auto_increment,
  `date` varchar(10) NOT NULL,
  `host_referer` varchar(127) NOT NULL,
  `keyword` varchar(255) NOT NULL,
  `nb_item` int(11) NOT NULL,
  `percents` decimal(5,2) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_days_pages`
-- 

CREATE TABLE `allmystats_days_pages` (
  `date` varchar(10) NOT NULL,
  `pages_name` varchar(255) NOT NULL,
  `visitors` int(11) NOT NULL,
  `visited_pages` int(11) NOT NULL,
  PRIMARY KEY  (`date`,`pages_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_monthly_keywords`
-- 

CREATE TABLE `allmystats_monthly_keywords` (
  `id` int(11) NOT NULL auto_increment,
  `date` varchar(7) NOT NULL,
  `host_referer` varchar(127) NOT NULL,
  `keyword` varchar(255) NOT NULL,
  `nb_item` int(11) NOT NULL,
  `percents` decimal(5,2) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_page_bad_agent`
-- 

CREATE TABLE `allmystats_page_bad_agent` (
  `code` bigint(20) NOT NULL default '0',
  `page` varchar(255) NOT NULL,
  `visits` int(11) NOT NULL default '0',
  `hour` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`code`,`page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_page_bot`
-- 

CREATE TABLE `allmystats_page_bot` (
  `code` bigint(20) NOT NULL default '0',
  `page` varchar(255) NOT NULL,
  `visits` int(11) NOT NULL default '0',
  `hour` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`code`,`page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_page_visitor`
-- 

CREATE TABLE `allmystats_page_visitor` (
  `code` bigint(20) NOT NULL default '0',
  `page` varchar(255) NOT NULL,
  `visits` int(11) NOT NULL default '0',
  `hour` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`code`,`page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_unique_bad_agent`
-- 

CREATE TABLE `allmystats_unique_bad_agent` (
  `agent` varchar(255) default NULL,
  `type` char(1) default NULL,
  `referer` varchar(512) default NULL,
  `ip` varchar(50) NOT NULL default '',
  `date` varchar(10) NOT NULL default '',
  `reverse_dns` varchar(100) default NULL,
  `code` bigint(20) NOT NULL auto_increment,
  `country` varchar(50) default NULL,
  `visits` int(11) NOT NULL default '0',
  PRIMARY KEY  (`code`),
  KEY `ADDR` (`ip`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_unique_bot`
-- 

CREATE TABLE `allmystats_unique_bot` (
  `agent` varchar(255) default NULL,
  `referer` varchar(512) default NULL,
  `ip` varchar(50) NOT NULL default '',
  `date` varchar(10) default NULL,
  `reverse_dns` varchar(100) default NULL,
  `code` bigint(20) NOT NULL auto_increment,
  `country` varchar(50) default NULL,
  `visits` int(11) NOT NULL default '0',
  PRIMARY KEY  (`code`),
  KEY `ADDR` (`ip`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;
  
-- --------------------------------------------------------

-- 
-- Structure de la table `allmystats_unique_visitor`
-- 

CREATE TABLE `allmystats_unique_visitor` (
  `agent` varchar(255) default NULL,
  `referer` varchar(512) default NULL,
  `ip` varchar(50) NOT NULL default '',
  `date` varchar(10) default NULL,
  `reverse_dns` varchar(100) default NULL,
  `code` bigint(20) NOT NULL auto_increment,
  `country` varchar(50) default NULL,
  `visits` int(11) NOT NULL default '0',
  PRIMARY KEY  (`code`),
  KEY `ADDR` (`ip`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8
  COLLATE utf8_unicode_ci;

-- --------------------------------------------------------

